// OpenGL.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "CG_Projekt.h"
#include "opengl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGL

IMPLEMENT_DYNCREATE(COpenGL, CFrameWnd)

COpenGL::COpenGL()
{
	// Klasseninitialisierungen
	m_structOGLStatus.bInitOGL			= GL_FALSE;
	m_structOGLStatus.bPerspective		= GL_TRUE;
	m_structOGLStatus.bLightMode		= GL_TRUE;
	m_structOGLStatus.bBlend			= GL_FALSE;
	m_structOGLStatus.bZbuffer			= GL_TRUE;
	m_structOGLStatus.bFillModeLines	= GL_FALSE;
	m_structOGLStatus.bLight			= GL_TRUE;
	m_structOGLStatus.bShadingSmooth	= GL_TRUE;
	m_structOGLStatus.bFog				= GL_TRUE;
	m_structOGLStatus.bTexture			= GL_TRUE;

	// Initialisierung der Lichtquellen
	m_structOGLStatus.bLight0 = GL_FALSE;
	m_structOGLStatus.bLight1 = GL_FALSE;
	m_structOGLStatus.bLight2 = GL_FALSE;

	// Initialisierung der Texturen
	m_TexturNamen.Rasen				= 0;
	m_TexturNamen.BeamerBild		= 0;

	m_TexturNamen.RoboKoerper		= 0;
	m_TexturNamen.RoboKopf			= 0;

	// zeichnen von Elementen
	m_structOGLStatus.bKos = GL_FALSE;

	// Viewpoint festlegen
	m_structOGLKamera.vKameraViewPoint.x = 45.0;
	m_structOGLKamera.vKameraViewPoint.y = 30.0;
	m_structOGLKamera.vKameraViewPoint.z = 45.0;

	m_structOGLKamera.rotate.x = 25.0;
	m_structOGLKamera.rotate.y = 45.0;
	m_structOGLKamera.rotate.z = 0.0;

	// Mouse initialisieren
	m_structGlobMouse.LastState = -1;
	m_structGlobMouse.MoveX 	= 35;	
	m_structGlobMouse.MoveY 	= 20;
	m_structGlobMouse.Radius 	= 60;
	m_structGlobMouse.CurX		= 20;
	m_structGlobMouse.CurY		= 35;
	m_structGlobMouse.Zoom		= 10;

	m_structGlobMouse.ButtonL = false;
	m_structGlobMouse.ButtonR = false;

	// Roboterbewegung initialisierung
	m_structMoveRobo.MoveBackward = false;
	m_structMoveRobo.MoveForward = false;
	m_structMoveRobo.MoveLeft = false;
	m_structMoveRobo.MoveRight = false;

	m_structMoveRobo.RoboStandort.x = 10.0;
	m_structMoveRobo.RoboStandort.y = 0.0;
	m_structMoveRobo.RoboStandort.z = 10.0;
	m_structMoveRobo.RoboDrehwinkel = 0.0;

	m_structMoveRobo.RoboStandortNeu.x = 10.0;
	m_structMoveRobo.RoboStandortNeu.y = 0.0;
	m_structMoveRobo.RoboStandortNeu.z = 10.0;

	m_structMoveRobo.Kopf = 0.0;

	m_structMoveRobo.ArmLinks = 0.0;
	m_structMoveRobo.ArmRechts = 0.0;
	m_structMoveRobo.Unterarm = -45.0;
	m_structMoveRobo.UnterarmLinks = -45.0;

	m_structMoveRobo.Hand = 0.0;
	m_structMoveRobo.Finger = 0.0;

	m_structMoveRobo.SpotCutOff = 30.0f;
	m_structMoveRobo.SpotExponent = 5.0f;

	// Clipplanes
	m_structClipplanes.left		=	-0.5;			// left Plane
	m_structClipplanes.right	=	+0.5;			// right Plane
	m_structClipplanes.up		=	-0.5;			// upper Plane
	m_structClipplanes.down		=	+0.5;			// lower Plane
	m_structClipplanes.front	=	+1;				// near
	m_structClipplanes.back		=	+1000;			// far

	// Standard-Farbdefinitionen
	// RGBA lokal definieren
	fRGBAColor Weiss				= {1.0F,1.0F,1.0F,0.5F};
	fRGBAColor Schwarz				= {0.0F,0.0F,0.0F,0.5F};
	fRGBAColor Rot					= {1.0F,0.0F,0.0F,0.5F};
	fRGBAColor Gruen				= {0.0F,1.0F,0.0F,0.5F};
	fRGBAColor Blau					= {0.0F,0.0F,1.0F,0.5F};
	fRGBAColor Gelb					= {1.0F,1.0F,0.0F,0.5F};
	fRGBAColor Cyan					= {0.0F,1.0F,1.0F,0.5F};
	fRGBAColor Magenta				= {1.0F,0.0F,1.0F,0.5F};
	fRGBAColor Orange				= {1.0F,0.5F,0.0F,0.5F};
	fRGBAColor Braun				= {0.5F,0.25F,0.0F,0.5F};
	fRGBAColor Lila					= {0.5F,0.0F,0.5F,0.5F};
	fRGBAColor Olivgruen			= {0.3F,0.5F,0.0F,0.5F};
	fRGBAColor Dunkelgruen			= {0.0F,0.5F,0.0F,0.5F};
	fRGBAColor Marineblau			= {0.0F,0.0F,0.5F,0.5F};
	fRGBAColor Tuerkis				= {0.0F,0.5F,0.5F,0.5F};
	fRGBAColor Backsteinrot			= {0.75F,0.0F,0.0F,0.5F};
	fRGBAColor Grau					= {0.5F,0.5F,0.5F,0.5F};
	fRGBAColor Silber				= {0.75F,0.75F,0.75F,0.5F};

	// Global abspeichern
	m_fStdFarben.WEISS			= Weiss;
	m_fStdFarben.SCHWARZ		= Schwarz;
	m_fStdFarben.ROT			= Rot;
	m_fStdFarben.GRUEN			= Gruen;
	m_fStdFarben.BLAU			= Blau;
	m_fStdFarben.GELB			= Gelb;
	m_fStdFarben.CYAN			= Cyan;
	m_fStdFarben.MAGENTA		= Magenta;
	m_fStdFarben.ORANGE			= Orange;
	m_fStdFarben.BRAUN			= Braun;
	m_fStdFarben.LILA			= Lila;
	m_fStdFarben.OLIVGRUEN		= Olivgruen;
	m_fStdFarben.DUNKELGRUEN	= Dunkelgruen;
	m_fStdFarben.MARINEBLAU		= Marineblau;
	m_fStdFarben.TUERKIS		= Tuerkis;
	m_fStdFarben.BACKSTEINROT	= Backsteinrot;
	m_fStdFarben.GRAU			= Grau;
	m_fStdFarben.SILBER			= Silber;

}

COpenGL::~COpenGL()
{
	HGLRC hglrc = wglGetCurrentContext();			// RC holen
	wglMakeCurrent(NULL,NULL);						// RC deaktivieren
	wglDeleteContext(hglrc);						// RC entgltig lschen
}


BEGIN_MESSAGE_MAP(COpenGL, CFrameWnd)
	//{{AFX_MSG_MAP(COpenGL)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten COpenGL 

bool COpenGL::InitOpenGL()
{	// OpenGL initialisieren

	if (Create (
		NULL,
		"Ausgabefenster",
		WS_CLIPCHILDREN
			| WS_CLIPSIBLINGS
			| WS_OVERLAPPEDWINDOW,
		CRect(155,0,800,600),
		NULL,
		NULL,
		WS_EX_TOPMOST,
		NULL))
	{
		if (!SetRenderingContext())				// RC-DC Verbindung setzen
			return false;						// Fehler -> Abbruch

		m_structOGLStatus.bInitOGL = GL_TRUE;
		return true;
	}

	return false;

}

bool COpenGL::SetRenderingContext()
{

	// Verbindet den Rendering-Kontext RC mit dem Device-Kontext DC
	PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),
		1,
		PFD_DRAW_TO_WINDOW
		| PFD_DRAW_TO_BITMAP
		| PFD_SUPPORT_OPENGL
		| PFD_DOUBLEBUFFER,
		PFD_TYPE_RGBA,
		32,							// Farbpuffertiefe
		0, 0, 0, 0, 0, 0,			// Farb-Bits
		0, 0,						// Alpha-Bits
		0, 0, 0, 0, 0,				// Accu-Bits
		16,							// 16 Bit Z-Buffer
		0,							// Stencil-Puffer
		0,							// Aux-Puffer
		0,							// Layertyp
		0,							// Overlay / Underlay -Planes
		0,							// Layer-Mask
		0,							// Transparenz UnderlayPlane
		0							// Layer-Masken
	};
	CDC* pcdc=GetDC();				// lokaler Zeiger auf eigenen DC
	HDC hdc=pcdc->m_hDC;			// lokales Handle auf eigenen DC

	int iPixelFormat				// Pixelformat auswhlen
		= ChoosePixelFormat(hdc, &pfd);
	SetPixelFormat(					// Pixelformat setzen
		hdc,						// Handle auf DC
		iPixelFormat,				// Pixelformat mitteilen
		&pfd);
	HGLRC hglrc =					// Render-Context fr OGL erzeugen
		wglCreateContext(hdc);
	if (hglrc==NULL) return false;	// Fehler! -> Abbruch
	if (!wglMakeCurrent(			// aktuelle DC-RC Verbindung setzen
		hdc,
		hglrc)) return false;		// Fehler! -> Abbruch

	return true;
}

bool COpenGL::OpenGLSzene()
{
	// Initialisierung von OpenGL
	wglMakeCurrent(						// Windows-OGL-Verbindung setzen
		wglGetCurrentDC(),				// aktuellen DC holen
		wglGetCurrentContext());		// aktuellen RC holen

	SetAttribs();

	// Texturen laden
	LoadPrepareCurTexture("Texturen/rasen.bmp",				// Textur fr das Grundstck laden
		&m_TexturNamen.Rasen, GL_NEAREST, GL_NEAREST);
	LoadPrepareCurTexture("Texturen/beamer.bmp",			// Textur fr das Beamerbild laden
		&m_TexturNamen.BeamerBild, GL_LINEAR, GL_LINEAR_MIPMAP_NEAREST);
	LoadPrepareCurTexture("Texturen/koerper.bmp",			// Textur fr den Kopf des Robo laden
		&m_TexturNamen.RoboKoerper, GL_LINEAR, GL_LINEAR);
	LoadPrepareCurTexture("Texturen/kopf.bmp",				// Textur fr den Krper des Robo laden
		&m_TexturNamen.RoboKopf, GL_LINEAR, GL_LINEAR);

	// Lichtquellen definieren (statisch)

		// Variablendefinitionen zum Licht
		// 1. Lichtquelle (Parallelstrahler)
		GLfloat LAmbient[4] = {0.1F,0.1F,0.1F,1.0F};
		GLfloat	LDiffuse[4] = {0.7F,0.7F,0.7F,1.0F};
		GLfloat LSpecular[4] = {0.3F,0.3F,0.3F,1.0F};
		GLfloat LPosition[4] = {0.5F,1.0F,0.0F,0.0F};
		GLfloat LSpotDirec[3] = {0.0F,0.0F,0.0F};
		GLfloat LSpotCutOff = 180.0F;
		GLfloat LSpotExponent = 0.0F;
		GLfloat LAttenuationConst = 1.0F;
		GLfloat LAttenuationLinear = 0.0F;
		GLfloat LAttenuationQuadrat = 0.0F;

		// 2. & 3. Lichtquelle (Laternen)
		GLfloat LAmbient1[4] = {0.02F,0.02F,0.02F,1.0F};
		GLfloat	LDiffuse1[4] = {1.0F,1.0F,1.0F,1.0F};
		GLfloat LSpecular1[4] = {0.3F,0.3F,0.3F,1.0F};
		GLfloat LSpotCutOff1 = 180.0F;
		GLfloat LSpotExponent1 = 0.0F;
		GLfloat LAttenuationConst1 = 0.8F;
		GLfloat LAttenuationLinear1 = 0.08F;
		GLfloat LAttenuationQuadrat1 = 0.03F;

		// 4. Lichtquelle (Strahler des Robo)
		GLfloat LAmbient3[4] = {0.0F,0.0F,0.0F,1.0F};
		GLfloat	LDiffuse3[4] = {1.0F,0.0F,0.0F,1.0F};
		GLfloat LSpecular3[4] = {1.0F,0.0F,0.0F,1.0F};
		GLfloat LAttenuationConst3 = 0.1F;
		GLfloat LAttenuationLinear3 = 0.05F;
		GLfloat LAttenuationQuadrat3 = 0.0F;

		// 5. Lichtquelle (Beamer)
		GLfloat LAmbient4[4] = {0.0F,0.0F,0.0F,1.0F};
		GLfloat	LDiffuse4[4] = {0.8F,0.9F,0.8F,1.0F};
		GLfloat LSpecular4[4] = {0.2F,0.2F,0.2F,1.0F};
		GLfloat LPosition4[4] = {0.0F,0.0F,0.0F,1.0F};
		GLfloat LSpotDirec4[3] = {0.0F,1.0F,0.0F};
		GLfloat LSpotCutOff4 = 7.0F;
		GLfloat LSpotExponent4 = 10.0F;
		GLfloat LAttenuationConst4 = 0.2F;
		GLfloat LAttenuationLinear4 = 0.05F;
		GLfloat LAttenuationQuadrat4 = 0.0F;

		// Variablendefinitionen zum Material
		GLfloat MAmbient[4] = {0.9F,0.9F,0.9F,1.0F};
		GLfloat MDiffuse[4] = {0.5F,0.5F,0.5F,1.0F};
		GLfloat MSpecular[4] = {0.0F,0.0F,0.0F,1.0F};
		//GLfloat MEmission[4] = {0.0F,0.0F,0.0F,1.0F};
		//GLfloat MShininess = 0.0F;

		// Definition der Lichtquellen (statisch)
		// 1. Lichtquelle (Parallelstrahler)
		glLightfv(GL_LIGHT0,GL_AMBIENT				,&LAmbient[0]);
		glLightfv(GL_LIGHT0,GL_DIFFUSE				,&LDiffuse[0]);
		glLightfv(GL_LIGHT0,GL_SPECULAR				,&LSpecular[0]);
		glLightfv(GL_LIGHT0,GL_POSITION				,&LPosition[0]);
		glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION		,&LSpotDirec[0]);
		glLightf(GL_LIGHT0,GL_SPOT_CUTOFF			,LSpotCutOff);
		glLightf(GL_LIGHT0,GL_SPOT_EXPONENT			,LSpotExponent);
		glLightf(GL_LIGHT0,GL_CONSTANT_ATTENUATION
					,LAttenuationConst);
		glLightf(GL_LIGHT0,GL_LINEAR_ATTENUATION
					,LAttenuationLinear);
		glLightf(GL_LIGHT0,GL_QUADRATIC_ATTENUATION
					,LAttenuationQuadrat);

		// 2. Lichtquelle (Laterne 1)
		glLightfv(GL_LIGHT1,GL_AMBIENT				,&LAmbient1[0]);
		glLightfv(GL_LIGHT1,GL_DIFFUSE				,&LDiffuse1[0]);
		glLightfv(GL_LIGHT1,GL_SPECULAR				,&LSpecular1[0]);
		glLightf(GL_LIGHT1,GL_SPOT_CUTOFF			,LSpotCutOff1);
		glLightf(GL_LIGHT1,GL_SPOT_EXPONENT			,LSpotExponent1);
		glLightf(GL_LIGHT1,GL_CONSTANT_ATTENUATION
					,LAttenuationConst1);
		glLightf(GL_LIGHT1,GL_LINEAR_ATTENUATION
					,LAttenuationLinear1);
		glLightf(GL_LIGHT1,GL_QUADRATIC_ATTENUATION
					,LAttenuationQuadrat1);

		// 3. Lichtquelle (Laterne 2)
		glLightfv(GL_LIGHT2,GL_AMBIENT				,&LAmbient1[0]);
		glLightfv(GL_LIGHT2,GL_DIFFUSE				,&LDiffuse1[0]);
		glLightfv(GL_LIGHT2,GL_SPECULAR				,&LSpecular1[0]);
		glLightf(GL_LIGHT2,GL_SPOT_CUTOFF			,LSpotCutOff1);
		glLightf(GL_LIGHT2,GL_SPOT_EXPONENT			,LSpotExponent1);
		glLightf(GL_LIGHT2,GL_CONSTANT_ATTENUATION
					,LAttenuationConst1);
		glLightf(GL_LIGHT2,GL_LINEAR_ATTENUATION
					,LAttenuationLinear1);
		glLightf(GL_LIGHT2,GL_QUADRATIC_ATTENUATION
					,LAttenuationQuadrat1);

		// 4. Lichtquelle (Strahler des Robo)
		glLightfv(GL_LIGHT3,GL_AMBIENT				,&LAmbient3[0]);
		glLightfv(GL_LIGHT3,GL_DIFFUSE				,&LDiffuse3[0]);
		glLightfv(GL_LIGHT3,GL_SPECULAR				,&LSpecular3[0]);
		glLightf(GL_LIGHT3,GL_CONSTANT_ATTENUATION
					,LAttenuationConst3);
		glLightf(GL_LIGHT3,GL_LINEAR_ATTENUATION
					,LAttenuationLinear3);
		glLightf(GL_LIGHT3,GL_QUADRATIC_ATTENUATION
					,LAttenuationQuadrat3);

		// 5. Lichtquelle (Beamer)
		glLightfv(GL_LIGHT4,GL_AMBIENT				,&LAmbient4[0]);
		glLightfv(GL_LIGHT4,GL_DIFFUSE				,&LDiffuse4[0]);
		glLightfv(GL_LIGHT4,GL_SPECULAR				,&LSpecular4[0]);
		glLightf(GL_LIGHT4,GL_SPOT_CUTOFF			,LSpotCutOff4);
		glLightf(GL_LIGHT4,GL_SPOT_EXPONENT			,LSpotExponent4);
		glLightf(GL_LIGHT4,GL_CONSTANT_ATTENUATION
					,LAttenuationConst4);
		glLightf(GL_LIGHT4,GL_LINEAR_ATTENUATION
					,LAttenuationLinear4);
		glLightf(GL_LIGHT4,GL_QUADRATIC_ATTENUATION
					,LAttenuationQuadrat4);

		// Standard-Materialdefinitionbefehle
		glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT,&MAmbient[0]);
		glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE,&MDiffuse[0]);
		glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,&MSpecular[0]);
		//glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,&MEmission[0]);
		//glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,MShininess);

		// Nebel-Definition
		glFogi(GL_FOG_MODE, GL_LINEAR);					// Nebel-Modus
		glFogfv(GL_FOG_COLOR, &m_fStdFarben.GRAU.Red);	// Farbe des Nebels
		glFogf(GL_FOG_DENSITY, 0.35f);					// Fog-Density
		glHint(GL_FOG_HINT, GL_NICEST);					// Fog-Hint
		glFogf(GL_FOG_START, 0.0f);						// Start
		glFogf(GL_FOG_END, 400.0f);					// End

	// Szenenobjekte zeichen (statische Listen)

	// globale Punktdefinitionen
		// der Grundflche
		dVektor V1 = {-5.0,0.0,-5.0};
		dVektor V2 = {-5.0,0.0,-4.0};
		dVektor V3 = {-5.0,0.0,-3.0};
		dVektor V4 = {-5.0,0.0,-2.0};
		dVektor V5 = {-5.0,0.0,-1.0};
		dVektor V6 = {-5.0,0.0,0.0};
		dVektor V7 = {-5.0,0.0,1.0};
		dVektor V8 = {-5.0,0.0,2.0};
		dVektor V9 = {-5.0,0.0,3.0};
		dVektor V10 = {-5.0,0.0,4.0};
		dVektor V11 = {-5.0,0.0,5.0};
		dVektor V12 = {-4.0,0.0,-5.0};
		dVektor V13 = {-4.0,0.0,-4.0};
		dVektor V14 = {-4.0,0.0,-3.0};
		dVektor V15 = {-4.0,0.0,-2.0};
		dVektor V16 = {-4.0,0.0,-1.0};
		dVektor V17 = {-4.0,0.0,0.0};
		dVektor V18 = {-4.0,0.0,1.0};
		dVektor V19 = {-4.0,0.0,2.0};
		dVektor V20 = {-4.0,0.0,3.0};
		dVektor V21 = {-4.0,0.0,4.0};
		dVektor V22 = {-4.0,0.0,5.0};
		dVektor V23 = {-3.0,0.0,-5.0};
		dVektor V24 = {-3.0,0.0,-4.0};
		dVektor V25 = {-3.0,0.0,-3.0};
		dVektor V26 = {-3.0,0.0,-2.0};
		dVektor V27 = {-3.0,0.0,-1.0};
		dVektor V28 = {-3.0,0.0,0.0};
		dVektor V29 = {-3.0,0.0,1.0};
		dVektor V30 = {-3.0,0.0,2.0};
		dVektor V31 = {-3.0,0.0,3.0};
		dVektor V32 = {-3.0,0.0,4.0};
		dVektor V33 = {-3.0,0.0,5.0};
		dVektor V34 = {-2.0,0.0,-5.0};
		dVektor V35 = {-2.0,0.0,-4.0};
		dVektor V36 = {-2.0,0.0,-3.0};
		dVektor V37 = {-2.0,0.0,-2.0};
		dVektor V38 = {-2.0,0.0,-1.0};
		dVektor V39 = {-2.0,0.0,0.0};
		dVektor V40 = {-2.0,0.0,1.0};
		dVektor V41 = {-2.0,0.0,2.0};
		dVektor V42 = {-2.0,0.0,3.0};
		dVektor V43 = {-2.0,0.0,4.0};
		dVektor V44 = {-2.0,0.0,5.0};
		dVektor V45 = {-1.0,0.0,-5.0};
		dVektor V46 = {-1.0,0.0,-4.0};
		dVektor V47 = {-1.0,0.0,-3.0};
		dVektor V48 = {-1.0,0.0,-2.0};
		dVektor V49 = {-1.0,0.0,-1.0};
		dVektor V50 = {-1.0,0.0,0.0};
		dVektor V51 = {-1.0,0.0,1.0};
		dVektor V52 = {-1.0,0.0,2.0};
		dVektor V53 = {-1.0,0.0,3.0};
		dVektor V54 = {-1.0,0.0,4.0};
		dVektor V55 = {-1.0,0.0,5.0};
		dVektor V56 = {0.0,0.0,-5.0};
		dVektor V57 = {0.0,0.0,-4.0};
		dVektor V58 = {0.0,0.0,-3.0};
		dVektor V59 = {0.0,0.0,-2.0};
		dVektor V60 = {0.0,0.0,-1.0};
		dVektor V61 = {0.0,0.0,0.0};
		dVektor V62 = {0.0,0.0,1.0};
		dVektor V63 = {0.0,0.0,2.0};
		dVektor V64 = {0.0,0.0,3.0};
		dVektor V65 = {0.0,0.0,4.0};
		dVektor V66 = {0.0,0.0,5.0};
		dVektor V67 = {1.0,0.0,-5.0};
		dVektor V68 = {1.0,0.0,-4.0};
		dVektor V69 = {1.0,0.0,-3.0};
		dVektor V70 = {1.0,0.0,-2.0};
		dVektor V71 = {1.0,0.0,-1.0};
		dVektor V72 = {1.0,0.0,0.0};
		dVektor V73 = {1.0,0.0,1.0};
		dVektor V74 = {1.0,0.0,2.0};
		dVektor V75 = {1.0,0.0,3.0};
		dVektor V76 = {1.0,0.0,4.0};
		dVektor V77 = {1.0,0.0,5.0};
		dVektor V78 = {2.0,0.0,-5.0};
		dVektor V79 = {2.0,0.0,-4.0};
		dVektor V80 = {2.0,0.0,-3.0};
		dVektor V81 = {2.0,0.0,-2.0};
		dVektor V82 = {2.0,0.0,-1.0};
		dVektor V83 = {2.0,0.0,0.0};
		dVektor V84 = {2.0,0.0,1.0};
		dVektor V85 = {2.0,0.0,2.0};
		dVektor V86 = {2.0,0.0,3.0};
		dVektor V87 = {2.0,0.0,4.0};
		dVektor V88 = {2.0,0.0,5.0};
		dVektor V89 = {3.0,0.0,-5.0};
		dVektor V90 = {3.0,0.0,-4.0};
		dVektor V91 = {3.0,0.0,-3.0};
		dVektor V92 = {3.0,0.0,-2.0};
		dVektor V93 = {3.0,0.0,-1.0};
		dVektor V94 = {3.0,0.0,0.0};
		dVektor V95 = {3.0,0.0,1.0};
		dVektor V96 = {3.0,0.0,2.0};
		dVektor V97 = {3.0,0.0,3.0};
		dVektor V98 = {3.0,0.0,4.0};
		dVektor V99 = {3.0,0.0,5.0};
		dVektor V100 = {4.0,0.0,-5.0};
		dVektor V101 = {4.0,0.0,-4.0};
		dVektor V102 = {4.0,0.0,-3.0};
		dVektor V103 = {4.0,0.0,-2.0};
		dVektor V104 = {4.0,0.0,-1.0};
		dVektor V105 = {4.0,0.0,0.0};
		dVektor V106 = {4.0,0.0,1.0};
		dVektor V107 = {4.0,0.0,2.0};
		dVektor V108 = {4.0,0.0,3.0};
		dVektor V109 = {4.0,0.0,4.0};
		dVektor V110 = {4.0,0.0,5.0};
		dVektor V111 = {5.0,0.0,-5.0};
		dVektor V112 = {5.0,0.0,-4.0};
		dVektor V113 = {5.0,0.0,-3.0};
		dVektor V114 = {5.0,0.0,-2.0};
		dVektor V115 = {5.0,0.0,-1.0};
		dVektor V116 = {5.0,0.0,0.0};
		dVektor V117 = {5.0,0.0,1.0};
		dVektor V118 = {5.0,0.0,2.0};
		dVektor V119 = {5.0,0.0,3.0};
		dVektor V120 = {5.0,0.0,4.0};
		dVektor V121 = {5.0,0.0,5.0};

		// Leinwand
		dVektor VL1 = {-1.0,0.0,0.0};
		dVektor VL2 = {-0.5,0.0,0.0};
		dVektor VL3 = {0.0,0.0,0.0};
		dVektor VL4 = {0.5,0.0,0.0};
		dVektor VL5 = {1.0,0.0,0.0};
		dVektor VL6 = {-1.0,0.5,0.0};
		dVektor VL7 = {-0.5,0.5,0.0};
		dVektor VL8 = {0.0,0.5,0.0};
		dVektor VL9 = {0.5,0.5,0.0};
		dVektor VL10 = {1.0,0.5,0.0};
		dVektor VL11 = {-1.0,1.0,0.0};
		dVektor VL12 = {-0.5,1.0,0.0};
		dVektor VL13 = {0.0,1.0,0.0};
		dVektor VL14 = {0.5,1.0,0.0};
		dVektor VL15 = {1.0,1.0,0.0};
		dVektor VL16 = {-1.0,1.5,0.0};
		dVektor VL17 = {-0.5,1.5,0.0};
		dVektor VL18 = {0.0,1.5,0.0};
		dVektor VL19 = {0.5,1.5,0.0};
		dVektor VL20 = {1.0,1.5,0.0};
		dVektor VL21 = {-1.0,2.0,0.0};
		dVektor VL22 = {-0.5,2.0,0.0};
		dVektor VL23 = {0.0,2.0,0.0};
		dVektor VL24 = {0.5,2.0,0.0};
		dVektor VL25 = {1.0,2.0,0.0};

		// Mast fr die Leinwand
		dVektor VL26 = {-0.5,0.0,-0.5};
		dVektor VL27 = {-0.5,1.0,-0.5};
		dVektor VL28 = {-0.5,0.0,0.5};
		dVektor VL29 = {-0.5,1.0,0.5};
		dVektor VL30 = {0.5,0.0,0.5};
		dVektor VL31 = {0.5,1.0,0.5};
		dVektor VL32 = {0.5,0.0,-0.5};
		dVektor VL33 = {0.5,1.0,-0.5};

		// Beamer
		dVektor VB1 = {-1.0,0.0,-2.0};
		dVektor VB2 = {-1.0,2.0,-2.0};
		dVektor VB3 = {-1.0,0.0,2.0};
		dVektor VB4 = {-1.0,2.0,2.0};
		dVektor VB5 = {1.0,0.0,2.0};
		dVektor VB6 = {1.0,2.0,2.0};
		dVektor VB7 = {1.0,0.0,-2.0};
		dVektor VB8 = {1.0,2.0,-2.0};

			// Linse
			dVektor VB9 = {-0.5,0.0,-0.5};
			dVektor VB10 = {-1.0,1.0,-1.0};
			dVektor VB11 = {-0.5,0.0,0.5};
			dVektor VB12 = {-1.0,1.0,1.0};
			dVektor VB13 = {0.5,0.0,0.5};
			dVektor VB14 = {1.0,1.0,1.0};
			dVektor VB15 = {0.5,0.0,-0.5};
			dVektor VB16 = {1.0,1.0,-1.0};

			// Beamerbild
			dVektor VB17 = {-4.0,5.0,-23.90};
			dVektor VB18 = {4.0,5.0,-23.90};
			dVektor VB19 = {-4.0,11.0,-23.90};
			dVektor VB20 = {4.0,11.0,-23.90};

		
		// Roboter
			// Fahrgestell
			dVektor VR1 = {-1.0,-1.0,1.0};
			dVektor VR2 = {-1.0,1.0,1.0};
			dVektor VR3 = {1.0,1.0,1.0};
			dVektor VR4 = {1.0,-1.0,1.0};

			dVektor VR5 = {-0.5,-1.0,0.4};
			dVektor VR6 = {-0.5,-1.0,1.0};
			dVektor VR7 = {0.5,-1.0,0.4};
			dVektor VR8 = {0.5,-1.0,1.0};
			dVektor VR9 = {0.5,1.0,0.4};
			dVektor VR10 = {0.5,1.0,1.0};
			dVektor VR11 = {-0.5,1.0,0.4};
			dVektor VR12 = {-0.5,1.0,1.0};

			// Rder
			dVektor VRR1 = {0.0,0.0,0.0};			// Mittelpunkt

				// innrerer Kreis
			dVektor VRR2 = {0.15,0.0,0.0};
			dVektor VRR3 = {0.13,0.075,0.0};
			dVektor VRR4 = {0.075,0.13,0.0};
			dVektor VRR5 = {0.0,0.15,0.0};
			dVektor VRR6 = {-0.075,0.13,0.0};
			dVektor VRR7 = {-0.13,0.075,0.0};
			dVektor VRR8 = {-0.15,0.0,0.0};
			dVektor VRR9 = {-0.13,-0.075,0.0};
			dVektor VRR10 = {-0.075,-0.13,0.0};
			dVektor VRR11 = {0.0,-0.15,0.0};
			dVektor VRR12 = {0.075,-0.13,0.0};
			dVektor VRR13 = {0.13,-0.075,0.0};

				// mittlerer Kreis
			dVektor VRR14 = {0.3,0.0,0.0};
			dVektor VRR15 = {0.26,0.15,0.0};
			dVektor VRR16 = {0.15,0.26,0.0};
			dVektor VRR17 = {0.0,0.3,0.0};
			dVektor VRR18 = {-0.15,0.26,0.0};
			dVektor VRR19 = {-0.26,0.15,0.0};
			dVektor VRR20 = {-0.3,0.0,0.0};
			dVektor VRR21 = {-0.26,-0.15,0.0};
			dVektor VRR22 = {-0.15,-0.26,0.0};
			dVektor VRR23 = {0.0,-0.3,0.0};
			dVektor VRR24 = {0.15,-0.26,0.0};
			dVektor VRR25 = {0.26,-0.15,0.0};

				// usserer Kreis
			dVektor VRR26 = {0.45,0.0,0.0};
			dVektor VRR27 = {0.39,0.225,0.0};
			dVektor VRR28 = {0.225,0.39,0.0};
			dVektor VRR29 = {0.0,0.45,0.0};
			dVektor VRR30 = {-0.225,0.39,0.0};
			dVektor VRR31 = {-0.39,0.225,0.0};
			dVektor VRR32 = {-0.45,0.0,0.0};
			dVektor VRR33 = {-0.39,-0.225,0.0};
			dVektor VRR34 = {-0.225,-0.39,0.0};
			dVektor VRR35 = {0.0,-0.45,0.0};
			dVektor VRR36 = {0.225,-0.39,0.0};
			dVektor VRR37 = {0.39,-0.225,0.0};

			// Arm 2
			dVektor VR13 = {-0.1,-0.1,1.1};
			dVektor VR14 = {-0.1,-0.1,2.0};
			dVektor VR15 = {-0.1,0.1,1.1};
			dVektor VR16 = {-0.1,0.1,2.0};
			dVektor VR17 = {0.1,0.1,1.1};
			dVektor VR18 = {0.1,0.1,2.0};
			dVektor VR19 = {0.1,-0.1,1.1};
			dVektor VR20 = {0.1,-0.1,2.0};

			// Arm 1 Unterarm
			dVektor VR21 = {-0.1,-0.1,0.25};
			dVektor VR22 = {-0.1,-0.1,0.9};
			dVektor VR23 = {-0.1,0.1,0.25};
			dVektor VR24 = {-0.1,0.1,0.9};
			dVektor VR25 = {0.1,0.1,0.25};
			dVektor VR26 = {0.1,0.1,0.9};
			dVektor VR27 = {0.1,-0.1,0.25};
			dVektor VR28 = {0.1,-0.1,0.9};

			// Hand
			dVektor VR29 = {-0.2,-0.2,0.25};
			dVektor VR30 = {-0.2,-0.2,0.2};
			dVektor VR31 = {-0.2,0.2,0.25};
			dVektor VR32 = {-0.2,0.2,0.2};
			dVektor VR33 = {0.2,0.2,0.25};
			dVektor VR34 = {0.2,0.2,0.2};
			dVektor VR35 = {0.2,-0.2,0.25};
			dVektor VR36 = {0.2,-0.2,0.2};
			
			dVektor VR37 = {-0.2,-0.18,0.2};
			dVektor VR38 = {-0.2,-0.18,0.05};
			dVektor VR39 = {-0.2,-0.15,0.2};
			dVektor VR40 = {-0.2,-0.15,0.05};
			dVektor VR41 = {0.2,-0.15,0.2};
			dVektor VR42 = {0.2,-0.15,0.05};
			dVektor VR43 = {0.2,-0.18,0.2};
			dVektor VR44 = {0.2,-0.18,0.05};

			// Strahler
			dVektor VR45 = {-0.1,-0.1,0.25};
			dVektor VR46 = {-0.2,-0.2,0.05};
			dVektor VR47 = {-0.1,0.1,0.25};
			dVektor VR48 = {-0.2,0.2,0.05};
			dVektor VR49 = {0.1,0.1,0.25};
			dVektor VR50 = {0.2,0.2,0.05};
			dVektor VR51 = {0.1,-0.1,0.25};
			dVektor VR52 = {0.2,-0.2,0.05};
	
	// Koordinatensystem zeichnen
	glNewList((GLint) KOORDINATENSYSTEM,GL_COMPILE);
		glPushAttrib(GL_LIGHTING_BIT);
		glPushMatrix();
		glDisable(GL_LIGHTING);
		glLineWidth(3);
		glBegin(GL_LINES);
			//X-Achse
			glColor4fv(&m_fStdFarben.ROT.Red);
			glVertex3d(0.0,0.0,0.0);
			glVertex3d(7.0,0.0,0.0);

			// Y-Achse
			glColor4fv(&m_fStdFarben.GRUEN.Red);
			glVertex3d(0.0,0.0,0.0);
			glVertex3d(0.0,7.0,0.0);

			// Z-Achse
			glColor4fv(&m_fStdFarben.BLAU.Red);
			glVertex3d(0.0,0.0,0.0);
			glVertex3d(0.0,0.0,7.0);
		glEnd();
		glLineWidth(1);
		glPopMatrix();
		glPopAttrib();
	glEndList();

	// Grundflche zeichnen
	glNewList((GLint) GRUNDSTUECK_TEIL,GL_COMPILE);
		glPushMatrix();
		
		if (m_structOGLStatus.bTexture == GL_TRUE)
			glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, m_TexturNamen.Rasen);

		glRotated(180.0,0.0,0.0,1.0);
		glBegin(GL_TRIANGLE_STRIP);

			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.OLIVGRUEN,
						GL_FRONT,
						0.80F,
						0.60F,
						0.10F);
			else
				glColor4fv(&m_fStdFarben.OLIVGRUEN.Red);

			glNormal3d(0.0,-1.0,0.0);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V1.x);
			glTexCoord2d(0.0, 2.0);
			glVertex3dv(&V12.x);
			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V2.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V13.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V3.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V14.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V4.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V15.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V5.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V16.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V6.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V17.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V7.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V18.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V8.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V19.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V9.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V20.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V10.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V21.x);
			
			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V11.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V22.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V33.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V21.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V32.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V20.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V31.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V19.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V30.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V18.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V29.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V17.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V28.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V16.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V27.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V15.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V26.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V14.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V25.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V13.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V24.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V12.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V23.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V34.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V24.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V35.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V25.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V36.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V26.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V37.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V27.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V38.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V28.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V39.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V29.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V40.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V30.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V41.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V31.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V42.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V32.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V43.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V33.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V44.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V55.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V43.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V54.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V42.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V53.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V41.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V52.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V40.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V51.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V39.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V50.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V38.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V49.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V37.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V48.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V36.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V47.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V35.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V46.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V34.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V45.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V56.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V46.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V57.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V47.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V58.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V48.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V59.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V49.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V60.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V50.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V61.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V51.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V62.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V52.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V63.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V53.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V64.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V54.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V65.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V55.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V66.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V77.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V65.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V76.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V64.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V75.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V63.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V74.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V62.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V73.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V61.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V72.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V60.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V71.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V59.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V70.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V58.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V69.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V57.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V68.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V56.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V67.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V78.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V68.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V79.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V69.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V80.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V70.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V81.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V71.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V82.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V72.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V83.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V73.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V84.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V74.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V85.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V75.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V86.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V76.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V87.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V77.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V88.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V99.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V87.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V98.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V86.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V97.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V85.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V96.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V84.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V95.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V83.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V94.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V82.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V93.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V81.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V92.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V80.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V91.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V79.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V90.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V78.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V89.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V100.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V90.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V101.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V91.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V102.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V92.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V103.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V93.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V104.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V94.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V105.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V95.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V106.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V96.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V107.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V97.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V108.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V98.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V109.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V99.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V110.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V121.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V109.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V120.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V108.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V119.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V107.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V118.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V106.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V117.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V105.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V116.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V104.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V115.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V103.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V114.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V102.x);

			glTexCoord2d(1.0, 0.0);
			glVertex3dv(&V113.x);

			glTexCoord2d(1.0, 1.0);
			glVertex3dv(&V101.x);

			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V112.x);

			glTexCoord2d(0.0, 1.0);
			glVertex3dv(&V100.x);

			glTexCoord2d(2.0, 1.0);
			glVertex3dv(&V111.x);
		glEnd(); 
/*

		glBegin(GL_QUADS);
			CalcNormale(&V1,&V11,&V111);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glColor4fv(&m_fStdFarben.DUNKELGRUEN.Red);
			glTexCoord2d(0.0, 2.0);
			glVertex3dv(&V1.x);
			glTexCoord2d(2.0, 2.0);
			glVertex3dv(&V11.x);
			glTexCoord2d(2.0, 0.0);
			glVertex3dv(&V121.x);
			glTexCoord2d(0.0, 0.0);
			glVertex3dv(&V111.x);
		glEnd();
*/

		glDisable(GL_TEXTURE_2D);
		glPopMatrix();
		glPopAttrib();
	glEndList();

	// Das Grundstck
	glNewList((GLint) GRUNDSTUECK,GL_COMPILE);
		glPushMatrix();
			glTranslated(-20.0,0.0,-20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(-10.0,0.0,-20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(0.0,0.0,-20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(10.0,0.0,-20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(20.0,0.0,-20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();

		glPushMatrix();
			glTranslated(-20.0,0.0,-10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(-10.0,0.0,-10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(0.0,0.0,-10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(10.0,0.0,-10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(20.0,0.0,-10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();

		glPushMatrix();
			glTranslated(-20.0,0.0,0.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(-10.0,0.0,0.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(10.0,0.0,0.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(20.0,0.0,0.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();

		glPushMatrix();
			glTranslated(-20.0,0.0,10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(-10.0,0.0,10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(0.0,0.0,10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(10.0,0.0,10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(20.0,0.0,10.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();

		glPushMatrix();
			glTranslated(-20.0,0.0,20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(-10.0,0.0,20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(0.0,0.0,20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(10.0,0.0,20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
		glPushMatrix();
			glTranslated(20.0,0.0,20.0);
			glCallList((GLint) GRUNDSTUECK_TEIL);
		glPopMatrix();
	glEndList();

	// Rad zeichnen (Robofahrgestell)
	glNewList((GLint) RADTEIL1,GL_COMPILE);		// Liste fr Radfelge
		glPushMatrix();

			// innerer Kreis
			glBegin(GL_TRIANGLE_FAN);
				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.GRAU,
					GL_FRONT,
					0.50F,
					0.50F,
					0.50F);
				else
					glColor4fv(&m_fStdFarben.GRAU.Red);

				CalcNormale(&VRR1,&VRR2,&VRR3);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR1.x);
				glVertex3dv(&VRR2.x);
				glVertex3dv(&VRR3.x);

				CalcNormale(&VRR1,&VRR3,&VRR4);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR4.x);

				CalcNormale(&VRR1,&VRR4,&VRR5);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR5.x);

				CalcNormale(&VRR1,&VRR5,&VRR6);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR6.x);

				CalcNormale(&VRR1,&VRR6,&VRR7);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR7.x);

				CalcNormale(&VRR1,&VRR7,&VRR8);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR8.x);

				CalcNormale(&VRR1,&VRR8,&VRR9);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR9.x);

				CalcNormale(&VRR1,&VRR9,&VRR10);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR10.x);

				CalcNormale(&VRR1,&VRR10,&VRR11);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR11.x);

				CalcNormale(&VRR1,&VRR11,&VRR12);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR12.x);

				CalcNormale(&VRR1,&VRR12,&VRR13);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR13.x);

				CalcNormale(&VRR1,&VRR13,&VRR2);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR2.x);
				
			glEnd();

			// mittlerer Kreis
			glBegin(GL_TRIANGLE_FAN);
				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
						0.90F,
						0.80F,
						0.20F);
				else
					glColor4fv(&m_fStdFarben.SILBER.Red);

				CalcNormale(&VRR1,&VRR14,&VRR15);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR1.x);
				glVertex3dv(&VRR14.x);
				glVertex3dv(&VRR15.x);

				CalcNormale(&VRR1,&VRR15,&VRR16);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR16.x);

				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.CYAN,
						GL_FRONT,
						0.90F,
						0.80F,
						0.20F);
				else
					glColor4fv(&m_fStdFarben.CYAN.Red);

				CalcNormale(&VRR1,&VRR16,&VRR17);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR17.x);

				CalcNormale(&VRR1,&VRR17,&VRR18);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR18.x);

				CalcNormale(&VRR1,&VRR18,&VRR19);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR19.x);

				CalcNormale(&VRR1,&VRR19,&VRR20);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR20.x);

				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.SILBER,
						GL_FRONT,
						0.90F,
						0.80F,
						0.20F);
				else
					glColor4fv(&m_fStdFarben.SILBER.Red);

				CalcNormale(&VRR1,&VRR20,&VRR21);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR21.x);

				CalcNormale(&VRR1,&VRR21,&VRR22);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR22.x);

				CalcNormale(&VRR1,&VRR22,&VRR23);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR23.x);

				CalcNormale(&VRR1,&VRR23,&VRR24);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR24.x);

				CalcNormale(&VRR1,&VRR24,&VRR25);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR25.x);

				CalcNormale(&VRR1,&VRR25,&VRR15);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR14.x);
				
			glEnd();

			// usserer Kreis
			glBegin(GL_TRIANGLE_FAN);
				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.SILBER,
						GL_FRONT,
						0.90F,
						0.80F,
						0.20F);
				else
					glColor4fv(&m_fStdFarben.SILBER.Red);

				CalcNormale(&VRR1,&VRR26,&VRR27);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR1.x);
				glVertex3dv(&VRR26.x);
				glVertex3dv(&VRR27.x);

				CalcNormale(&VRR1,&VRR27,&VRR28);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR28.x);

				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.CYAN,
						GL_FRONT,
						0.90F,
						0.80F,
						0.20F);
				else
					glColor4fv(&m_fStdFarben.CYAN.Red);

				CalcNormale(&VRR1,&VRR28,&VRR29);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR29.x);

				CalcNormale(&VRR1,&VRR29,&VRR30);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR30.x);

				CalcNormale(&VRR1,&VRR30,&VRR31);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR31.x);

				CalcNormale(&VRR1,&VRR31,&VRR32);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR32.x);

				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.SILBER,
						GL_FRONT,
						0.90F,
						0.80F,
						0.20F);
				else
					glColor4fv(&m_fStdFarben.SILBER.Red);

				CalcNormale(&VRR1,&VRR32,&VRR33);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR33.x);

				CalcNormale(&VRR1,&VRR33,&VRR34);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR34.x);

				CalcNormale(&VRR1,&VRR34,&VRR35);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR35.x);

				CalcNormale(&VRR1,&VRR35,&VRR36);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR36.x);

				CalcNormale(&VRR1,&VRR36,&VRR37);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR37.x);

				CalcNormale(&VRR1,&VRR37,&VRR26);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VRR26.x);
				
			glEnd();
		glPopMatrix();
	glEndList();

	m_pRadPart2 = gluNewQuadric();	// neue Quadric anfordern
	if (m_pRadPart2 > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) RADTEIL2,GL_COMPILE);		// Liste fr Radzylinder
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pRadPart2,						// Texturnutzung
				GL_FALSE);
			gluQuadricOrientation(m_pRadPart2,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pRadPart2,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pRadPart2,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pRadPart2,						// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SCHWARZ,
					GL_FRONT,
					0.40F,
					0.20F,
					0.00F);
			else
				glColor4fv(&m_fStdFarben.SCHWARZ.Red);		// Farbe (schwarz)

			gluCylinder(m_pRadPart2,						// Befehl fr Zylinder
				0.45,										// Bodenradius
				0.45,										// Kopfradius
				0.3,										// Hhe
				9,											// Umfangsaufteilung
				9);											// Hhenaufteilung

			glPopMatrix();
		glEndList();
	}

	// ein Rad
	glNewList((GLint) RAD,GL_COMPILE);
		glPushMatrix();
			glRotated(90.0,0.0,1.0,0.0);
			glPushMatrix();
				glRotated(180.0,1.0,0.0,0.0);
				glRotated(90.0,0.0,0.0,1.0);
				glCallList((GLint) RADTEIL1);
			glPopMatrix();
			glCallList((GLint) RADTEIL2);
			glTranslated(0.0,0.0,0.3);
			glCallList((GLint) RADTEIL1);
		glPopMatrix();
	glEndList();

	// Roboterfahrgestell zeichnen
	glNewList((GLint) FAHRGESTELL,GL_COMPILE);
		glPushMatrix();
		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.GRAU,
					GL_FRONT,
					0.80F,
					0.80F,
					0.40F);
		else
			glColor4fv(&m_fStdFarben.GRAU.Red);

		glBegin(GL_QUADS);
			glNormal3d(0.0,1.0,0.0);
			glVertex3dv(&VR4.x);
			glVertex3dv(&VR3.x);
			glVertex3dv(&VR2.x);
			glVertex3dv(&VR1.x);
		glEnd();

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VR12,&VR11,&VR6);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR5.x);
			glVertex3dv(&VR6.x);
			glVertex3dv(&VR11.x);
			glVertex3dv(&VR12.x);

			CalcNormale(&VR10,&VR9,&VR12);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR9.x);
			glVertex3dv(&VR10.x);

			CalcNormale(&VR8,&VR7,&VR10);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR7.x);
			glVertex3dv(&VR8.x);

			CalcNormale(&VR6,&VR5,&VR8);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR5.x);
			glVertex3dv(&VR6.x);
		glEnd();
		
		glPopMatrix();
	glEndList();

	// Roboterrumpf zeichen
	m_pRumpf = gluNewQuadric();	// neue Quadric anfordern
	if (m_pRumpf > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) ROBORUMPF,GL_COMPILE);		// Liste fr den Roboterrumpf
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pRumpf,						// Texturnutzung
				GL_TRUE);
			gluQuadricOrientation(m_pRumpf,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pRumpf,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pRumpf,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pRumpf,					// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			glTranslated(0.0,0.0,1.0);
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);		// Farbe

			if (m_structOGLStatus.bTexture == GL_TRUE)
				glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, m_TexturNamen.RoboKoerper);

			gluCylinder(m_pRumpf,							// Befehl fr Zylinder
				1.0,										// Bodenradius
				1.0,										// Kopfradius
				1.5,										// Hhe
				30,											// Umfangsaufteilung
				30);										// Hhenaufteilung

			glDisable(GL_TEXTURE_2D);

			glPopMatrix();
		glEndList();
	}

	// Armgelenk zeichnen
	m_pArmgelenk = gluNewQuadric();		// neue Quadric anfordern
	if (m_pArmgelenk > 0)				// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) ARMGELENK,GL_COMPILE);		// Liste fr ein Armgelenk
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pArmgelenk,						// Texturnutzung
				GL_FALSE);
			gluQuadricOrientation(m_pArmgelenk,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pArmgelenk,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pArmgelenk,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pArmgelenk,					// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			glTranslated(0.0,0.0,2.0);						// Armhhe setzen
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);				// Farbe grau
	
			gluSphere(m_pArmgelenk,							// Befehl fr Kugel
				0.3,										// Radius
				12,											// Umfangsaufteilung
				12);										// Hhenaufteilung

			glPopMatrix();
		glEndList();
	}

	// Armgelenk 2 zeichnen
	m_pArmgelenk2 = gluNewQuadric();		// neue Quadric anfordern
	if (m_pArmgelenk > 0)				// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) ARMGELENK2,GL_COMPILE);		// Liste fr ein Armgelenk
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pArmgelenk2,					// Texturnutzung
				GL_FALSE);
			gluQuadricOrientation(m_pArmgelenk2,				// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pArmgelenk2,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pArmgelenk2,					// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pArmgelenk2,					// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			glTranslated(0.0,0.0,1.0);						// Armhhe setzen
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);				// Farbe grau
			
			gluSphere(m_pArmgelenk2,						// Befehl fr Kugel
				0.2,										// Radius
				12,											// Umfangsaufteilung
				12);											// Hhenaufteilung
			
			glPopMatrix();
		glEndList();
	}

	// Arm Variante 1 Unterarm
	glNewList((GLint) UNTERARM,GL_COMPILE);
		glPushMatrix();
		
		glBegin(GL_QUAD_STRIP);
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);

			CalcNormale(&VR24,&VR23,&VR22);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR21.x);
			glVertex3dv(&VR22.x);
			glVertex3dv(&VR23.x);
			glVertex3dv(&VR24.x);

			CalcNormale(&VR26,&VR25,&VR24);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR25.x);
			glVertex3dv(&VR26.x);

			CalcNormale(&VR28,&VR27,&VR26);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR27.x);
			glVertex3dv(&VR28.x);

			CalcNormale(&VR22,&VR21,&VR28);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR21.x);
			glVertex3dv(&VR22.x);
		glEnd();
		
		glPopMatrix();
	glEndList();

	// Arm Variante 2 zeichnen
	glNewList((GLint) ARM2,GL_COMPILE);
		glPushMatrix();
		
		glBegin(GL_QUAD_STRIP);
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);

			CalcNormale(&VR16,&VR15,&VR14);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR13.x);
			glVertex3dv(&VR14.x);
			glVertex3dv(&VR15.x);
			glVertex3dv(&VR16.x);

			CalcNormale(&VR18,&VR17,&VR16);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR17.x);
			glVertex3dv(&VR18.x);

			CalcNormale(&VR20,&VR19,&VR18);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR19.x);
			glVertex3dv(&VR20.x);

			CalcNormale(&VR14,&VR13,&VR19);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR13.x);
			glVertex3dv(&VR14.x);
		glEnd();
		
		glPopMatrix();
	glEndList();

	// Handflche zeichnen
	glNewList((GLint) HANDFLAECHE,GL_COMPILE);
		glPushMatrix();
		
		glBegin(GL_QUADS);
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);

			CalcNormale(&VR29,&VR31,&VR33);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR29.x);
			glVertex3dv(&VR31.x);
			glVertex3dv(&VR33.x);
			glVertex3dv(&VR35.x);

			CalcNormale(&VR32,&VR34,&VR36);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR30.x);
			glVertex3dv(&VR32.x);
			glVertex3dv(&VR34.x);
			glVertex3dv(&VR36.x);
		glEnd();

		// Handkrper
		glBegin(GL_QUAD_STRIP);
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);

			CalcNormale(&VR35,&VR36,&VR29);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR30.x);
			glVertex3dv(&VR29.x);
			glVertex3dv(&VR36.x);
			glVertex3dv(&VR35.x);

			CalcNormale(&VR33,&VR34,&VR35);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR34.x);
			glVertex3dv(&VR33.x);

			CalcNormale(&VR31,&VR32,&VR33);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR32.x);
			glVertex3dv(&VR31.x);

			CalcNormale(&VR29,&VR30,&VR31);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR30.x);
			glVertex3dv(&VR29.x);
		glEnd();

		glPopMatrix();
	glEndList();

	// "Finger" zeichnen
	glNewList((GLint) FINGER,GL_COMPILE);
		glPushMatrix();
		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
		else
			glColor4fv(&m_fStdFarben.SILBER.Red);

		glBegin(GL_QUADS);
			CalcNormale(&VR40,&VR42,&VR42);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR38.x);
			glVertex3dv(&VR40.x);
			glVertex3dv(&VR42.x);
			glVertex3dv(&VR44.x);
		glEnd();

		glBegin(GL_QUAD_STRIP);

			CalcNormale(&VR43,&VR44,&VR37);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR38.x);
			glVertex3dv(&VR37.x);
			glVertex3dv(&VR44.x);
			glVertex3dv(&VR43.x);

			CalcNormale(&VR41,&VR42,&VR43);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR42.x);
			glVertex3dv(&VR41.x);

			CalcNormale(&VR39,&VR40,&VR41);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR40.x);
			glVertex3dv(&VR39.x);

			CalcNormale(&VR37,&VR38,&VR39);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR38.x);
			glVertex3dv(&VR37.x);
		glEnd();
		
		glPopMatrix();
	glEndList();

	// Lichtstrahler zeichnen
	glNewList((GLint) STRAHLER,GL_COMPILE);
		glPushAttrib(GL_ENABLE_BIT);
		glPushMatrix();
		
		fRGBAColor Strahlerfarbe;

		glBegin(GL_QUAD_STRIP);
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);
			
			CalcNormale(&VR46,&VR45,&VR48);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR46.x);
			glVertex3dv(&VR45.x);
			glVertex3dv(&VR48.x);
			glVertex3dv(&VR47.x);

			CalcNormale(&VR48,&VR50,&VR49);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR50.x);
			glVertex3dv(&VR49.x);

			CalcNormale(&VR50,&VR52,&VR51);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR52.x);
			glVertex3dv(&VR51.x);

			CalcNormale(&VR52,&VR46,&VR45);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR46.x);
			glVertex3dv(&VR45.x);
		glEnd();

		glEnable(GL_BLEND);
		glBegin(GL_QUADS);
			
			Strahlerfarbe = m_fStdFarben.ROT;

			if (m_structOGLStatus.bLight2 == GL_TRUE)
				Strahlerfarbe.Alpha = 0.3F;
			else
				Strahlerfarbe.Alpha = 0.7F;

			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&Strahlerfarbe,
					GL_FRONT,
					0.90F,
					0.90F,
					0.90F);
			else
				glColor4fv(&Strahlerfarbe.Red);

			CalcNormale(&VR52,&VR50,&VR48);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VR46.x);
			glVertex3dv(&VR48.x);
			glVertex3dv(&VR50.x);
			glVertex3dv(&VR52.x);

		glEnd();
		glDisable(GL_BLEND);

		glPopMatrix();
		glPopAttrib();
	glEndList();


	// Roboterkopf zeichnen
	m_pKopf = gluNewQuadric();	// neue Quadric anfordern
	if (m_pKopf > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) KOPF,GL_COMPILE);		// Liste fr den Kopf
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pKopf,						// Texturnutzung
				GL_TRUE);
			gluQuadricOrientation(m_pKopf,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pKopf,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pKopf,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pKopf,						// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			glTranslated(0.0,0.0,2.5);						// auf Rumpf setzen
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.95F,
					0.95F,
					0.40F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);			// Farbe

			if (m_structOGLStatus.bTexture == GL_TRUE)
				glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, m_TexturNamen.RoboKopf);
			
			gluSphere(m_pKopf,								// Befehl fr Kugel
				0.98,										// Radius
				35,											// Umfangsaufteilung
				35);										// Hhenaufteilung

			glDisable(GL_TEXTURE_2D);

			glPopMatrix();
		glEndList();
	}

	// Laternenmast zeichnen
	m_pMast = gluNewQuadric();	// neue Quadric anfordern
	if (m_pMast > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) MAST,GL_COMPILE);		// Liste fr den Mast
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pMast,						// Texturnutzung
				GL_FALSE);
			gluQuadricOrientation(m_pMast,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pMast,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pMast,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pMast,						// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.90F,
					0.80F,
					0.20F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);			// Farbe (Silber)
			
			gluCylinder(m_pMast,							// Befehl fr Zylinder
				0.3,										// Bodenradius
				0.2,										// Kopfradius
				6.0,										// Hhe
				25,											// Umfangsaufteilung
				18);										// Hhenaufteilung

			glPopMatrix();
		glEndList();
	}

	// Laternenhalterung zeichnen
	m_pHalterung = gluNewQuadric();	// neue Quadric anfordern
	if (m_pHalterung > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
	{
		glNewList((GLint) HALTERUNG,GL_COMPILE);		// Liste fr die Halterung
			// Grunddefinitionen
			glPushMatrix();

			gluQuadricTexture(m_pHalterung,						// Texturnutzung
				GL_FALSE);
			gluQuadricOrientation(m_pHalterung,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pHalterung,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pHalterung,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pHalterung,					// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			glTranslated(0.0,0.0,5.5);
			glRotated(-50.0,1.0,0.0,0.0);					// Ausrichtung bestimmen
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.90F,
					0.80F,
					0.20F);
			else
				glColor4fv(&m_fStdFarben.SILBER.Red);			// Farbe (Silber)
			
			gluCylinder(m_pMast,							// Befehl fr Zylinder
				0.06,										// Bodenradius
				0.04,										// Kopfradius
				1.0,										// Hhe
				9,											// Umfangsaufteilung
				9);										// Hhenaufteilung

			glPopMatrix();
		glEndList();
	}

	// Laternenlampe zeichnen
	m_pLeuchter = gluNewQuadric();	// neue Quadric anfordern
	if (m_pLeuchter > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
	{
		fRGBAColor Leuchtfarbe;
		glNewList((GLint) LEUCHTER,GL_COMPILE);		// Liste fr den Leuchter
			// Grunddefinitionen
			glPushAttrib(GL_ENABLE_BIT);
			glPushMatrix();

			glEnable(GL_BLEND);

			gluQuadricTexture(m_pLeuchter,						// Texturnutzung
				GL_FALSE);
			gluQuadricOrientation(m_pLeuchter,					// Normalenausrichtung
				GLU_OUTSIDE);
			gluQuadricDrawStyle(m_pLeuchter,					// Darstellungsart
				GLU_FILL);
			gluQuadricNormals(m_pLeuchter,						// Normalen berechnen
				GLU_SMOOTH);
			gluQuadricCallback(m_pLeuchter,						// Rckrufe ablschen
				GLU_ERROR,
				NULL);

			// GL-Befehle zum Objekt
			glTranslated(0.0,1.0,5.6);						// an Halterung setzen
			if (m_structOGLStatus.bLight1 == GL_TRUE)		// Licht an
			{
				Leuchtfarbe = m_fStdFarben.ORANGE;
				Leuchtfarbe.Alpha = 0.5F;
			}
			else											// Licht aus
			{
				Leuchtfarbe = m_fStdFarben.WEISS;
				Leuchtfarbe.Alpha = 0.7F;
			}
			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&Leuchtfarbe,
					GL_FRONT,
					0.90F,
					0.90F,
					0.90F);
			else
				glColor4fv(&Leuchtfarbe.Red);
			
			gluSphere(m_pLeuchter,							// Befehl fr Zylinder
				0.5,										// Radius
				20,											// Umfangsaufteilung
				20);										// Hhenaufteilung

			glDisable(GL_BLEND);

			glPopMatrix();
			glPopAttrib();
		glEndList();
	}

	// Laterne zeichnen
	glNewList((GLint) LATERNE,GL_COMPILE);
		glPushMatrix();
		glCallList((GLint) LEUCHTER);
		glCallList((GLint) HALTERUNG);
		glCallList((GLint) MAST);
		glPopMatrix();
	glEndList();

	// Leinwandteil zeichnen
	glNewList((GLint) LEINWAND_TEIL,GL_COMPILE);
		glPushMatrix();

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.GRAU,
					GL_FRONT,
					0.90F,
					0.90F,
					0.70F);
		else
			glColor4fv(&m_fStdFarben.GRAU.Red);

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VL7,&VL6,&VL1);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL6.x);
			glVertex3dv(&VL1.x);
			glVertex3dv(&VL7.x);
			glVertex3dv(&VL2.x);

			CalcNormale(&VL8,&VL7,&VL2);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL8.x);
			glVertex3dv(&VL3.x);

			CalcNormale(&VL9,&VL8,&VL3);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL9.x);
			glVertex3dv(&VL4.x);

			CalcNormale(&VL10,&VL9,&VL4);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL10.x);
			glVertex3dv(&VL5.x);
		glEnd();

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VL12,&VL11,&VL6);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL11.x);
			glVertex3dv(&VL6.x);
			glVertex3dv(&VL12.x);
			glVertex3dv(&VL7.x);

			CalcNormale(&VL13,&VL12,&VL7);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL13.x);
			glVertex3dv(&VL8.x);

			CalcNormale(&VL14,&VL13,&VL8);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL14.x);
			glVertex3dv(&VL9.x);

			CalcNormale(&VL15,&VL14,&VL9);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL15.x);
			glVertex3dv(&VL10.x);
		glEnd();

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VL17,&VL16,&VL11);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL16.x);
			glVertex3dv(&VL11.x);
			glVertex3dv(&VL17.x);
			glVertex3dv(&VL12.x);

			CalcNormale(&VL18,&VL17,&VL12);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL18.x);
			glVertex3dv(&VL13.x);

			CalcNormale(&VL19,&VL18,&VL13);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL19.x);
			glVertex3dv(&VL14.x);

			CalcNormale(&VL20,&VL19,&VL14);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL20.x);
			glVertex3dv(&VL15.x);
		glEnd();

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VL22,&VL21,&VL16);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL21.x);
			glVertex3dv(&VL16.x);
			glVertex3dv(&VL22.x);
			glVertex3dv(&VL17.x);

			CalcNormale(&VL23,&VL22,&VL17);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL23.x);
			glVertex3dv(&VL18.x);

			CalcNormale(&VL24,&VL23,&VL18);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL24.x);
			glVertex3dv(&VL19.x);

			CalcNormale(&VL25,&VL24,&VL19);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL25.x);
			glVertex3dv(&VL20.x);

		glEnd();

		glPopMatrix();
	glEndList();

	// Leinwandmast (Teil) zeichnen
	glNewList((GLint) LEINWANDMAST_TEIL,GL_COMPILE);
		glPushMatrix();

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.90F,
					0.90F,
					0.70F);
		else
			glColor4fv(&m_fStdFarben.SILBER.Red);

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VL32,&VL33,&VL31);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL32.x);
			glVertex3dv(&VL33.x);
			glVertex3dv(&VL30.x);
			glVertex3dv(&VL31.x);

			CalcNormale(&VL30,&VL31,&VL29);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL28.x);
			glVertex3dv(&VL29.x);

			CalcNormale(&VL28,&VL29,&VL27);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL26.x);
			glVertex3dv(&VL27.x);

			CalcNormale(&VL26,&VL27,&VL33);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VL32.x);
			glVertex3dv(&VL33.x);
		glEnd();

		glPopMatrix();
	glEndList();

		// Leinwand zeichnen
	glNewList((GLint) LEINWAND,GL_COMPILE);
		glPushMatrix();
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);

			glTranslated(0.0,-2.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);

			glTranslated(0.0,-2.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);

			glTranslated(0.0,-2.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
			glTranslated(-2.0,0.0,0.0);
			glCallList((GLint) LEINWAND_TEIL);
		glPopMatrix();
	glEndList();

	// Leinwandmast zeichnen
	glNewList((GLint) LEINWANDMAST,GL_COMPILE);
		glPushMatrix();

			glTranslated(0.0,0.0,-24.5);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) LEINWANDMAST_TEIL);

		glPopMatrix();
	glEndList();

	// Beamer Mast (Teil) zeichnen
	glNewList((GLint) BEAMER_MAST_TEIL,GL_COMPILE);
		glPushMatrix();

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.90F,
					0.90F,
					0.70F);
		else
			glColor4fv(&m_fStdFarben.SILBER.Red);

		glLineWidth(5);

		glBegin(GL_LINE_LOOP);
			glVertex3dv(&VL30.x);
			glVertex3dv(&VL29.x);
			glVertex3dv(&VL28.x);
			glVertex3dv(&VL27.x);
			glVertex3dv(&VL26.x);
			glVertex3dv(&VL33.x);
			glVertex3dv(&VL32.x);
			glVertex3dv(&VL31.x);
		glEnd();

		glBegin(GL_LINE_LOOP);
			glVertex3dv(&VL30.x);
			glVertex3dv(&VL28.x);
			glVertex3dv(&VL26.x);
			glVertex3dv(&VL32.x);
		glEnd();

		glLineWidth(1);

		glPopMatrix();
	glEndList();

	// Beamerhalterung zeichnen
	glNewList((GLint) BEAMER_HALTERUNG,GL_COMPILE);
		glPushMatrix();

		m_pBeamer = gluNewQuadric();	// neue Quadric anfordern
		if (m_pLeuchter > 0)			// nur zeichnen, wenn Anforderung fehlerfrei
		{

				if(m_structOGLStatus.bLightMode == GL_FALSE)
					SetMatCol(&m_fStdFarben.SILBER,
							GL_FRONT,
							0.90F,
							0.90F,
							0.70F);
				else
					glColor4fv(&m_fStdFarben.SILBER.Red);

				// Grunddefinitionen
				gluQuadricTexture(m_pBeamer,						// Texturnutzung
					GL_FALSE);
				gluQuadricOrientation(m_pBeamer,					// Normalenausrichtung
					GLU_OUTSIDE);
				gluQuadricDrawStyle(m_pBeamer,						// Darstellungsart
					GLU_FILL);
				gluQuadricNormals(m_pBeamer,						// Normalen berechnen
					GLU_SMOOTH);
				gluQuadricCallback(m_pBeamer,						// Rckrufe ablschen
					GLU_ERROR,
					NULL);

				// GL-Befehle zum Objekt
				glTranslated(-20.0,0.02,0.0);					// auf Mast setzen
				glRotated(-90.0,1.0,0.0,0.0);
						
				gluDisk(m_pBeamer,								// Befehl fr Scheibe
					0.0,										// Lochkreisradius
					1.2,										// Radius
					10,											// Umfangsaufteilung
					10);										// Hhenaufteilung
		}

		glPopMatrix();

		glPushMatrix();

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.BRAUN,
					GL_FRONT,
					0.90F,
					0.70F,
					0.00F);
		else
			glColor4fv(&m_fStdFarben.BRAUN.Red);

		glLineWidth(3);

		glBegin(GL_LINE_STRIP);
			glVertex3d(-20.0,0.0,0.0);
			glVertex3d(-15.0,-0.33,0.0);
			glVertex3d(-10.0,-0.66,0.0);
			glVertex3d(-5.0,-1.0,0.0);
			glVertex3d(0.0,-1.33,0.0);
		glEnd();

		glLineWidth(1);

		glPopMatrix();
	glEndList();

	// Beamergehuse zeichnen
	glNewList((GLint) BEAMER_GEHAEUSE,GL_COMPILE);
		glPushMatrix();

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.90F,
					0.90F,
					0.70F);
		else
			glColor4fv(&m_fStdFarben.SILBER.Red);

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VB8,&VB6,&VB5);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB7.x);
			glVertex3dv(&VB8.x);
			glVertex3dv(&VB5.x);
			glVertex3dv(&VB6.x);

			CalcNormale(&VB6,&VB4,&VB3);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB3.x);
			glVertex3dv(&VB4.x);

			CalcNormale(&VB4,&VB2,&VB1);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB1.x);
			glVertex3dv(&VB2.x);

			CalcNormale(&VB2,&VB8,&VB7);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB7.x);
			glVertex3dv(&VB8.x);
		glEnd();

		glBegin(GL_QUADS);
			glNormal3d(0.0,-1.0,0.0);
			glVertex3dv(&VB1.x);
			glVertex3dv(&VB3.x);
			glVertex3dv(&VB5.x);
			glVertex3dv(&VB7.x);

			glNormal3d(0.0,1.0,0.0);
			glVertex3dv(&VB2.x);
			glVertex3dv(&VB4.x);
			glVertex3dv(&VB6.x);
			glVertex3dv(&VB8.x);
		glEnd();

		glPopMatrix();
	glEndList();

	// Beamerlinse zeichnen
	glNewList((GLint) BEAMER_LINSE,GL_COMPILE);
		glPushAttrib(GL_ENABLE_BIT);
		glPushMatrix();

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.SILBER,
					GL_FRONT,
					0.90F,
					0.90F,
					0.70F);
		else
			glColor4fv(&m_fStdFarben.SILBER.Red);

		glTranslated(0.0,1.0,-2.0);
		glRotated(-90,1.0,0.0,0.0);

		// Beamerlicht
		glLightfv(GL_LIGHT4,GL_POSITION				,&LPosition4[0]);
		glLightfv(GL_LIGHT4,GL_SPOT_DIRECTION		,&LSpotDirec4[0]);

		glBegin(GL_QUAD_STRIP);
			CalcNormale(&VB16,&VB14,&VB13);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB15.x);
			glVertex3dv(&VB16.x);
			glVertex3dv(&VB13.x);
			glVertex3dv(&VB14.x);

			CalcNormale(&VB14,&VB12,&VB11);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB11.x);
			glVertex3dv(&VB12.x);

			CalcNormale(&VB12,&VB10,&VB9);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB9.x);
			glVertex3dv(&VB10.x);

			CalcNormale(&VB10,&VB16,&VB15);
			glNormal3dv(&m_structOGLStatus.vLastNormale.x);
			glVertex3dv(&VB15.x);
			glVertex3dv(&VB16.x);
		glEnd();

		fRGBAColor Linsenfarbe = m_fStdFarben.WEISS;
		fRGBAColor Strahlfarbe = m_fStdFarben.WEISS;

		glEnable(GL_BLEND);

			if (m_structOGLStatus.bBeamer == GL_TRUE)
				Linsenfarbe.Alpha = 0.3F;
			else
				Linsenfarbe.Alpha = 0.7F;

			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&Linsenfarbe,
					GL_FRONT,
					0.90F,
					0.90F,
					0.90F);
			else
				glColor4fv(&Linsenfarbe.Red);

		glBegin(GL_QUADS);
			glNormal3d(0.0,1.0,0.0);
			glVertex3dv(&VB10.x);
			glVertex3dv(&VB12.x);
			glVertex3dv(&VB14.x);
			glVertex3dv(&VB16.x);
		glEnd();

		if (m_structOGLStatus.bBeamer == GL_TRUE)
		{
			Strahlfarbe.Alpha = 0.2F;

			if(m_structOGLStatus.bLightMode == GL_FALSE)
				SetMatCol(&Strahlfarbe,
					GL_FRONT,
					0.90F,
					0.90F,
					0.90F);
			else
				glColor4fv(&Strahlfarbe.Red);

			glBegin(GL_QUAD_STRIP);
				CalcNormale(&VB16,&VB14,&VB13);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VB15.x);
				glVertex3dv(&VB16.x);
				glVertex3dv(&VB13.x);
				glVertex3dv(&VB14.x);

				CalcNormale(&VB14,&VB12,&VB11);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VB11.x);
				glVertex3dv(&VB12.x);

				CalcNormale(&VB12,&VB10,&VB9);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VB9.x);
				glVertex3dv(&VB10.x);

				CalcNormale(&VB10,&VB16,&VB15);
				glNormal3dv(&m_structOGLStatus.vLastNormale.x);
				glVertex3dv(&VB15.x);
				glVertex3dv(&VB16.x);
		glEnd();
		}

		glDisable(GL_BLEND);

		glPopMatrix();
		glPopAttrib();
	glEndList();

		// Beamermast zeichnen
	glNewList((GLint) BEAMER_MAST,GL_COMPILE);
		glPushMatrix();

			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);
			glTranslated(0.0,1.0,0.0);
			glCallList((GLint) BEAMER_MAST_TEIL);

		glPopMatrix();
	glEndList();

		// Beamer zeichnen
	glNewList((GLint) BEAMER,GL_COMPILE);

		glPushMatrix();
			glTranslated(-20.0,0.0,0.0);
			glCallList((GLint) BEAMER_MAST);
		glPopMatrix();

		glPushMatrix();
			glTranslated(20.0,0.0,0.0);
			glCallList((GLint) BEAMER_MAST);
		glPopMatrix();

		glPushMatrix();
			glTranslated(0.0,11.0,0.0);
			glCallList((GLint) BEAMER_HALTERUNG);
		glPopMatrix();

		glPushMatrix();
			glTranslated(0.0,11.0,0.0);
			glRotated(180.0,0.0,1.0,0.0);
			glCallList((GLint) BEAMER_HALTERUNG);
		glPopMatrix();

		glPushMatrix();
			glTranslated(0.0,8.0,0.0);
			glRotated(-2.0,1.0,0.0,0.0);
			glCallList((GLint) BEAMER_GEHAEUSE);
			glCallList((GLint) BEAMER_LINSE);
		glPopMatrix();

	glEndList();

	// Beamerbild zeichnen
	glNewList((GLint) BEAMER_BILD,GL_COMPILE);
		glPushMatrix();

		if (m_structOGLStatus.bTexture == GL_TRUE)
			glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, m_TexturNamen.BeamerBild);

		if(m_structOGLStatus.bLightMode == GL_FALSE)
			SetMatCol(&m_fStdFarben.WEISS,
					GL_FRONT,
					0.90F,
					0.90F,
					0.70F);
		else
			glColor4fv(&m_fStdFarben.WEISS.Red);

		glBegin(GL_QUADS);
			glNormal3d(0.0,0.0,1.0);
			glTexCoord2d(0.0, 0.0);glVertex3dv(&VB17.x);
			glTexCoord2d(1.0, 0.0);glVertex3dv(&VB18.x);
			glTexCoord2d(1.0, 1.0);glVertex3dv(&VB20.x);
			glTexCoord2d(0.0, 1.0);glVertex3dv(&VB19.x);
		glEnd();

		glDisable(GL_TEXTURE_2D);

		glPopMatrix();
	glEndList();

	// Szene zeichnen
	DrawScene();

	return true;
}

bool COpenGL::SetCurPerspektive()
{
	// lokale Programmvariablen definieren
	CRect clientRect;					// MFC-Rechteckdef.
	GetClientRect(&clientRect);			// Fensterinfo holen
	GLsizei width =						// Breite Zeichenbereich
		(GLint) clientRect.right;
	GLsizei height =					// Hhe Zeichenbereich
		(GLint) clientRect.bottom;
	GLdouble ClientRatio =				// Breite zu Hhe Verhltnis
		(GLdouble) width/height;

	// Mouse Zeichenbereich setzen
	m_structGlobMouse.ScreenX = clientRect.right;			
	m_structGlobMouse.ScreenY = clientRect.bottom;
		// Szenen-Sichtweise definieren
	glMatrixMode(GL_PROJECTION);		// Matrix setzen
	glLoadIdentity();					// mit Einheitsmatrix init.

	// Perspektive setzen
	if (m_structOGLStatus.bPerspective == GL_TRUE)
		glFrustum(
			m_structClipplanes.left,			// left Plane
			m_structClipplanes.right,			// right Plane
			m_structClipplanes.up,				// upper Plane
			m_structClipplanes.down,			// lower Plane
			m_structClipplanes.front,			// near
			m_structClipplanes.back);			// far
	else
	{
		glOrtho(
			-m_structGlobMouse.Zoom,//abs((int)m_structGlobMouse.Zoom),					// left Plane
			+m_structGlobMouse.Zoom,//abs((int)m_structGlobMouse.Zoom),					// right Plane
			-m_structGlobMouse.Zoom,//abs((int)m_structGlobMouse.Zoom),					// upper Plane
			+m_structGlobMouse.Zoom,//abs((int)m_structGlobMouse.Zoom),					// lower Plane
			-1000,//abs((int)m_structGlobMouse.Zoom) * 1000.0f,			// near
			+2000);//abs((int)m_structGlobMouse.Zoom) * 1000.0f);		// far


	}

	//gluPerspective (30.0, (double)clientRect.right/(double)clientRect.bottom, 1, 2000);

	// ab jetzt wird auf der Modelierungsmatrix gearbeitet
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	// Berechnungen zur Ansichtstransformation
	GLfloat SzeneRotation = 360.0f - (GLfloat)m_structOGLKamera.rotate.y;

	glRotatef((GLfloat)m_structOGLKamera.rotate.x, 1.0, 0.0, 0.0);
	glRotatef(SzeneRotation, 0.0, 1.0, 0.0);
	glTranslatef(-(GLfloat)m_structOGLKamera.vKameraViewPoint.x,
				 -(GLfloat)m_structOGLKamera.vKameraViewPoint.y,
				 -(GLfloat)m_structOGLKamera.vKameraViewPoint.z);

/*
	double x,y,z, The,Phi;
	
	Phi = (double)m_structGlobMouse.MoveX / (double)m_structGlobMouse.ScreenX * M_PI * 2.0;
	The = (double)m_structGlobMouse.MoveY / (double)m_structGlobMouse.ScreenY * M_PI * 2.0;
	x = m_structGlobMouse.Radius * cos (Phi) * cos (The);
	y = m_structGlobMouse.Radius * sin (The);
	z = m_structGlobMouse.Radius * sin (Phi) * cos (The);
	int oben = (The <= 0.5 * M_PI || The > 1.5 * M_PI) * 2 - 1;

	gluLookAt (
		x,								// X Viewpoint
		y,								// Y Viewpoint
		z,								// Z Viewpoint
		
		0,								// X Szenenmittelpunkt
		0,								// Y Szenenmittelpunkt
		0,								// Z Szenenmittelpunkt

		0.00,							// X Ausrichtung Up-Vektor
		oben,							// Y Ausrichtung Up-Vektor
		0.00);							// Z Ausrichtung Up-Vektor
*/

	// Viewport festlegen
	if (ClientRatio <= 1.0)				// Hhe anpassen
	{
		glViewport(						// Viewport Darstellungsbereich definieren
			(GLint) 0,						// x-Fenster-Koordinate
			(GLint) (height*(1.0-ClientRatio)/2.0),	// y-Fenster-Koordinate
			(GLint) width,					// Darstellungsbreite
			(GLint) (height*ClientRatio));			// Darstellungshhe
	}
	else
	{
		glViewport(						// Viewport Darstellungsbereich definieren
			(GLint) (width*(1.0-(1.0/ClientRatio))/2.0),// x-Fenster-Koordinate
			(GLint) 0,						// y-Fenster-Koordinate
			(GLint) (width/ClientRatio),	// Darstellungsbreite
			(GLint) height);				// Darstellungshhe
	}

	return GL_TRUE;

}

bool COpenGL::SetCurModel()
{	// In dieser Funktion werden die vernderbaren Listen erstellt und schliesslich 
	// die Szene gezeichnet

	// Variablendefinitionen zum Licht (dynamisch)
	// 4. Lichtquelle (Strahler des Robo)
		GLfloat LSpotCutOff3 = m_structMoveRobo.SpotCutOff;
		GLfloat LSpotExponent3 = m_structMoveRobo.SpotExponent;

	// Definition der Lichtquellen (dynamisch)
		// Laterne 1
		GLfloat LPosition1[4] = {0.0F,0.0F,5.4F,1.0F};
		GLfloat LSpotDirec1[3] = {0.0F,0.0F,-5.4F};
		// Laterne 2
		GLfloat LPosition2[4] = {0.0F,0.0F,5.4F,1.0F};
		GLfloat LSpotDirec2[3] = {0.0F,0.0F,-5.4F};
		// Strahler
		GLfloat LPosition3[4] = {0.0F,0.0F,0.04F,1.0F};
		GLfloat LSpotDirec3[3] = {0.0F,0.0F,-0.04F};
		glLightf(GL_LIGHT3,GL_SPOT_CUTOFF			,LSpotCutOff3);
		glLightf(GL_LIGHT3,GL_SPOT_EXPONENT			,LSpotExponent3);


	// Arm 1
	glNewList((GLint) ARM1,GL_COMPILE);
		glPushMatrix();
			glCallList((GLint) ARMGELENK2);
			glTranslated(0.0,0.0,1.0);
			glRotated(m_structMoveRobo.Unterarm
						,1.0,0.0,0.0);
			glTranslated(0.0,0.0,-1.0);
			glCallList((GLint) UNTERARM);
			glCallList((GLint) HAND);
			glPopMatrix();
	glEndList();

	// Hand
	glNewList((GLint) HAND,GL_COMPILE);
		glPushMatrix();
			glRotated(m_structMoveRobo.Hand,
						0.0,0.0,1.0);
			glCallList((GLint) HANDFLAECHE);
			glPushMatrix();
				glTranslated(0.0,m_structMoveRobo.Finger,0.0);
				glCallList((GLint) FINGER);
			glPopMatrix();
			glRotated(180,0.0,0.0,1.0);
			glPushMatrix();
				glTranslated(0.0,m_structMoveRobo.Finger,0.0);
				glCallList((GLint) FINGER);
			glPopMatrix();
		glPopMatrix();
	glEndList();

	// linker Arm
	glNewList((GLint) ARM_LINKS,GL_COMPILE);
		glPushMatrix();
			glTranslated(1.0,0.0,0.0);
			glTranslated(0.0,0.0,2.0);
			glRotated(m_structMoveRobo.ArmLinks,				// Arm hoch & runter bewegen
						1.0,0.0,0.0);
			glTranslated(0.0,0.0,-2.0);
			glCallList((GLint) ARMGELENK);
			glTranslated(0.2,0.0,0.0);
			glCallList((GLint) ARM2);

			glCallList((GLint) ARMGELENK2);
			glTranslated(0.0,0.0,1.0);
			glRotated(m_structMoveRobo.UnterarmLinks
						,1.0,0.0,0.0);
			glTranslated(0.0,0.0,-1.0);
			glRotated(180,0.0,0.0,1.0);
			glCallList((GLint) UNTERARM);
			glCallList((GLint) STRAHLER);
			glLightfv(GL_LIGHT3,GL_POSITION				,&LPosition3[0]);
			glLightfv(GL_LIGHT3,GL_SPOT_DIRECTION		,&LSpotDirec3[0]);
		glPopMatrix();
	glEndList();

	// rechter Arm
	glNewList((GLint) ARM_RECHTS,GL_COMPILE);
		glPushMatrix();
			glTranslated(-1.0,0.0,0.0);
			glTranslated(0.0,0.0,2.0);
			glRotated(m_structMoveRobo.ArmRechts,				// Arm hoch & runter bewegen
						1.0,0.0,0.0);
			glTranslated(0.0,0.0,-2.0);
			glCallList((GLint) ARMGELENK);
			glTranslated(-0.2,0.0,0.0);
			glCallList((GLint) ARM2);
			glCallList((GLint) ARM1);
		glPopMatrix();
	glEndList();

	// Roboter zeichnen
	glNewList((GLint) ROBOTER,GL_COMPILE);
		
		// Rad vorne links
		glPushMatrix();
		glTranslated(0.5,-0.6,0.45);
		glRotated(m_structMoveRobo.WheelLeft,
					1.0,0.0,0.0);
		glCallList((GLint) RAD);
		glPopMatrix();
		
		// Rad vorne rechts
		glPushMatrix();
		glTranslated(-0.5,-0.6,0.45);
		glRotated(m_structMoveRobo.WheelRight,
					1.0,0.0,0.0);
		glRotated(180,0.0,1.0,0.0);
		glCallList((GLint) RAD);
		glPopMatrix();

		// Rad hinten links
		glPushMatrix();
		glTranslated(0.5,0.6,0.45);
		glRotated(m_structMoveRobo.WheelLeft,
					1.0,0.0,0.0);
		glCallList((GLint) RAD);
		glPopMatrix();

		// Rad hinten rechts
		glPushMatrix();
		glTranslated(-0.5,0.6,0.45);
		glRotated(m_structMoveRobo.WheelRight,
					1.0,0.0,0.0);
		glRotated(180,0.0,1.0,0.0);
		glCallList((GLint) RAD);
		glPopMatrix();

		// Fahrgestell
		glCallList((GLint) FAHRGESTELL);

		// Rumpf
		glCallList((GLint) ROBORUMPF);

		// Kopf
		glPushMatrix();
			glRotated(m_structMoveRobo.Kopf,0.0,0.0,1.0);
			glCallList((GLint) KOPF);
		glPopMatrix();
		
		// Arme
		glCallList((GLint) ARM_LINKS);
		glCallList((GLint) ARM_RECHTS);
		

	glEndList();

	// Komplette Szene zeichnen
	glNewList((GLint) SZENE,GL_COMPILE);
		glCallList((GLint) ATTRIBS);

		// Koordinatensystem
		if (m_structOGLStatus.bKos == GL_TRUE)
			glCallList((GLint) KOORDINATENSYSTEM);

		// Grundflche
		glPushAttrib(GL_LIGHTING_BIT);
			glCallList((GLint) GRUNDSTUECK);
		glPopAttrib();

		// Laterne 1
		glPushMatrix();
			glTranslated(-10.0,0.0,-5.0);
			glRotated(-90,0.0,1.0,0.0);
			glRotated(-90.0,1.0,0.0,0.0);					// Ausrichtung bestimmen
			glLightfv(GL_LIGHT1,GL_POSITION				,&LPosition1[0]);
			glLightfv(GL_LIGHT1,GL_SPOT_DIRECTION		,&LSpotDirec1[0]);	
			glCallList((GLint) LATERNE);
		glPopMatrix();

		// Laterne 2
		glPushMatrix();
			glTranslated(10.0,0.0,-5.0);
			glRotated(90,0.0,1.0,0.0);
			glRotated(-90.0,1.0,0.0,0.0);					// Ausrichtung bestimmen
			glLightfv(GL_LIGHT2,GL_POSITION				,&LPosition1[0]);
			glLightfv(GL_LIGHT2,GL_SPOT_DIRECTION		,&LSpotDirec1[0]);
			glCallList((GLint) LATERNE);
		glPopMatrix();

		// Leinwand
		glPushMatrix();
			glTranslated(-4.0,10.0,-23.98);
			glCallList((GLint) LEINWAND);
		glPopMatrix();
		glCallList((GLint) LEINWANDMAST);

		// Beamer
		glPushMatrix();
			glTranslated(0.0,0.0,24.0);
			glCallList((GLint) BEAMER);
		glPopMatrix();
		if (m_structOGLStatus.bBeamer == GL_TRUE)
			glCallList((GLint) BEAMER_BILD);

		// Roboter
		glPushMatrix();
			glTranslated(									// Zeichenposition bestimmen
				m_structMoveRobo.RoboStandort.x,
				m_structMoveRobo.RoboStandort.y,
				m_structMoveRobo.RoboStandort.z);
			glRotated(m_structMoveRobo.RoboDrehwinkel,
					  0.0,1.0,0.0);
			glRotated(-90.0,1.0,0.0,0.0);					// Ausrichtung bestimmen
			glCallList((GLint) ROBOTER);
		glPopMatrix();

	glEndList();
	
	// Szene darstellen
	glCallList((GLint) SZENE);

	return GL_TRUE;
}

void COpenGL::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Kamerasteuerung per Mouse
	double Radius, Phi, The;

	m_structGlobMouse.OldX = m_structGlobMouse.CurX;
	m_structGlobMouse.OldY = m_structGlobMouse.CurY;
	m_structGlobMouse.CurX = point.x;
	m_structGlobMouse.CurY = point.y;

	m_structGlobMouse.MoveX = m_structGlobMouse.CurX - m_structGlobMouse.OldX;
	m_structGlobMouse.MoveY = m_structGlobMouse.CurY - m_structGlobMouse.OldY;

	if (m_structGlobMouse.ButtonL == true)
	{
		m_structOGLKamera.rotate.x += m_structGlobMouse.MoveY;
		m_structOGLKamera.rotate.y -= m_structGlobMouse.MoveX;
	}
	else if (m_structGlobMouse.ButtonR == true)
	{
		Radius = m_structGlobMouse.MoveY;
		m_structGlobMouse.Zoom += m_structGlobMouse.MoveY;

		Phi = m_structOGLKamera.rotate.y * M_PI / 180;
		The = m_structOGLKamera.rotate.x * M_PI / 180;

		m_structOGLKamera.vKameraViewPoint.x += Radius * sin (Phi);
		m_structOGLKamera.vKameraViewPoint.y += Radius * sin (The);
		m_structOGLKamera.vKameraViewPoint.z += Radius * cos (Phi);
	}

	m_structGlobMouse.OldX = point.x;
	m_structGlobMouse.OldY = point.y;
/*	
	if (m_structGlobMouse.ButtonL == true)
	{
		m_structGlobMouse.MoveX += point.x - m_structGlobMouse.OldX;
		m_structGlobMouse.MoveY += point.y - m_structGlobMouse.OldY;
			
		if (m_structGlobMouse.MoveX > m_structGlobMouse.ScreenX)
				m_structGlobMouse.MoveX -= m_structGlobMouse.ScreenX;
		if (m_structGlobMouse.MoveX < 0)
				m_structGlobMouse.MoveX =+ m_structGlobMouse.ScreenX;
		if (m_structGlobMouse.MoveY > m_structGlobMouse.ScreenY)
				m_structGlobMouse.MoveY -= m_structGlobMouse.ScreenY;
		if (m_structGlobMouse.MoveY < 0)
				m_structGlobMouse.MoveY =+ m_structGlobMouse.ScreenY;
			
		m_structGlobMouse.OldX = point.x;
		m_structGlobMouse.OldY = point.y;

	}

	else if (m_structGlobMouse.ButtonR == true)
	{
		m_structGlobMouse.Radius += point.y - m_structGlobMouse.OldY;
		m_structGlobMouse.Radius = MAX (m_structGlobMouse.Radius,1);
		m_structGlobMouse.OldX = point.x;
		m_structGlobMouse.OldY = point.y;
	}
*/
	//OpenGLSzene();
	DrawScene();

	CFrameWnd::OnMouseMove(nFlags, point);
}

void COpenGL::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Linke Maustaste wurde gedrckt - definiert fr Kamerabewegung

	m_structGlobMouse.ButtonL = true;							// Flag L-Taste gedrckt
	m_structGlobMouse.OldX = point.x;							// Ausgangspunkt setzen (x)
	m_structGlobMouse.OldY = point.y;							// Ausgangspunkt setzen (y)

	CFrameWnd::OnLButtonDown(nFlags, point);
}

void COpenGL::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// Linke Maustaste losgelassen

	m_structGlobMouse.ButtonL = false;

	CFrameWnd::OnLButtonUp(nFlags, point);
}

void COpenGL::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// Rechte Maustaste wurde gedrckt - definiert fr Zoom

	m_structGlobMouse.ButtonR = true;							// Flag R-Taste gedrckt
	m_structGlobMouse.OldY = point.y;							// Ausgangswert fr Abstand

	CFrameWnd::OnRButtonDown(nFlags, point);
}

void COpenGL::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// Rechte Maustaste losgelassen

	m_structGlobMouse.ButtonR = false;

	CFrameWnd::OnRButtonUp(nFlags, point);
}

void COpenGL::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// Diese Funktion reagiert auf Tastatureingaben
	
	char lsChar;				// Zeichen der gedrckten Taste

	// Code der gedrckten Taste in Zeichen umwandeln
	lsChar = char(nChar);

	// Aktionen durchfhren
	switch (lsChar)
	{
		case 'W':			// Bewegung nach vorn
				if (!((m_structMoveRobo.RoboStandort.x <= -23.9) ||
					(m_structMoveRobo.RoboStandort.z <= -23.9) ||
					(m_structMoveRobo.RoboStandort.x >= 23.9) ||
					(m_structMoveRobo.RoboStandort.z >= 23.9)

					|| ((m_structMoveRobo.RoboStandort.x <= -8.7) &&
					(m_structMoveRobo.RoboStandort.x >= -11.3) &&
					(m_structMoveRobo.RoboStandort.z <= -3.7) &&
					(m_structMoveRobo.RoboStandort.z >= -6.3))

					|| ((m_structMoveRobo.RoboStandort.x >= 8.7) &&
					(m_structMoveRobo.RoboStandort.x <= 11.3) &&
					(m_structMoveRobo.RoboStandort.z <= -3.7) &&
					(m_structMoveRobo.RoboStandort.z >= -6.3))

					|| ((m_structMoveRobo.RoboStandort.x >= -0.51) &&
					(m_structMoveRobo.RoboStandort.x <= 0.51) &&
					(m_structMoveRobo.RoboStandort.z <= -22.9))

					|| ((m_structMoveRobo.RoboStandort.x <= -18.4) &&
					(m_structMoveRobo.RoboStandort.x >= -21.6) &&
					(m_structMoveRobo.RoboStandort.z >= 22.4))

					|| ((m_structMoveRobo.RoboStandort.x >= 18.4) &&
					(m_structMoveRobo.RoboStandort.x <= 21.6) &&
					(m_structMoveRobo.RoboStandort.z >= 22.4))
					))
				{
					m_structMoveRobo.RoboStandortNeu.x =
						m_structMoveRobo.RoboStandort.x + (
							0.1 * sin(m_structMoveRobo.RoboDrehwinkel * (M_PI / 180)));
					m_structMoveRobo.RoboStandortNeu.z =
						m_structMoveRobo.RoboStandort.z + (
							0.1 * cos(m_structMoveRobo.RoboDrehwinkel * (M_PI / 180)));
					
					if ((m_structMoveRobo.RoboStandortNeu.x < 23.9) &&
						(m_structMoveRobo.RoboStandortNeu.x > -23.9) &&
						(m_structMoveRobo.RoboStandortNeu.z < 23.9) &&
						(m_structMoveRobo.RoboStandortNeu.z > -23.9) &&

						!((m_structMoveRobo.RoboStandortNeu.x < -8.7) &&	
						(m_structMoveRobo.RoboStandortNeu.x > -11.3) &&
						(m_structMoveRobo.RoboStandortNeu.z < -3.7) &&
						(m_structMoveRobo.RoboStandortNeu.z > -6.3)) &&

						!((m_structMoveRobo.RoboStandortNeu.x > 8.7) &&	
						(m_structMoveRobo.RoboStandortNeu.x < 11.3) &&
						(m_structMoveRobo.RoboStandortNeu.z < -3.7) &&
						(m_structMoveRobo.RoboStandortNeu.z > -6.3)) &&

						!((m_structMoveRobo.RoboStandortNeu.x > -0.51) &&
						(m_structMoveRobo.RoboStandortNeu.x < 0.51) &&
						(m_structMoveRobo.RoboStandortNeu.z < -22.9)) &&

						!((m_structMoveRobo.RoboStandortNeu.x < -18.4) &&
						(m_structMoveRobo.RoboStandortNeu.x > -21.6) &&
						(m_structMoveRobo.RoboStandortNeu.z > 22.4)) &&

						!((m_structMoveRobo.RoboStandortNeu.x > 18.4) &&
						(m_structMoveRobo.RoboStandortNeu.x < 21.6) &&
						(m_structMoveRobo.RoboStandortNeu.z > 22.4))
						)
					{
						m_structMoveRobo.RoboStandort.x = m_structMoveRobo.RoboStandortNeu.x;
						m_structMoveRobo.RoboStandort.z = m_structMoveRobo.RoboStandortNeu.z;

						m_structMoveRobo.WheelLeft += 5.0;
						if (m_structMoveRobo.WheelLeft > 3590)
							m_structMoveRobo.WheelLeft = 0.0;

						m_structMoveRobo.WheelRight += 5.0;
						if (m_structMoveRobo.WheelRight > 3590)
							m_structMoveRobo.WheelRight = 0.0;
					}
				}
				break;
		case 'S':			// Bewegung nach Hinten
				if (!((m_structMoveRobo.RoboStandort.x <= -23.9) ||
					(m_structMoveRobo.RoboStandort.z <= -23.9) ||
					(m_structMoveRobo.RoboStandort.x >= 23.9) ||
					(m_structMoveRobo.RoboStandort.z >= 23.9)

					|| ((m_structMoveRobo.RoboStandort.x <= -8.7) &&
					(m_structMoveRobo.RoboStandort.x >= -11.3) &&
					(m_structMoveRobo.RoboStandort.z <= -3.7) &&
					(m_structMoveRobo.RoboStandort.z >= -6.3))

					|| ((m_structMoveRobo.RoboStandort.x >= 8.7) &&
					(m_structMoveRobo.RoboStandort.x <= 11.3) &&
					(m_structMoveRobo.RoboStandort.z <= -3.7) &&
					(m_structMoveRobo.RoboStandort.z >= -6.3))

					|| ((m_structMoveRobo.RoboStandort.x >= -0.51) &&
					(m_structMoveRobo.RoboStandort.x <= 0.51) &&
					(m_structMoveRobo.RoboStandort.z <= -22.9))

					|| ((m_structMoveRobo.RoboStandort.x <= -18.4) &&
					(m_structMoveRobo.RoboStandort.x >= -21.6) &&
					(m_structMoveRobo.RoboStandort.z >= 22.4))

					|| ((m_structMoveRobo.RoboStandort.x >= 18.4) &&
					(m_structMoveRobo.RoboStandort.x <= 21.6) &&
					(m_structMoveRobo.RoboStandort.z >= 22.4))
					))
				{
					m_structMoveRobo.RoboStandortNeu.x =
						m_structMoveRobo.RoboStandort.x - (
							0.1 * sin(m_structMoveRobo.RoboDrehwinkel * (M_PI / 180)));
					m_structMoveRobo.RoboStandortNeu.z =
						m_structMoveRobo.RoboStandort.z - (
							0.1 * cos(m_structMoveRobo.RoboDrehwinkel * (M_PI / 180)));

					if ((m_structMoveRobo.RoboStandortNeu.x < 23.9) &&
						(m_structMoveRobo.RoboStandortNeu.x > -23.9) &&
						(m_structMoveRobo.RoboStandortNeu.z < 23.9) &&
						(m_structMoveRobo.RoboStandortNeu.z > -23.9) &&

						!((m_structMoveRobo.RoboStandortNeu.x < -8.7) &&	
						(m_structMoveRobo.RoboStandortNeu.x > -11.3) &&
						(m_structMoveRobo.RoboStandortNeu.z < -3.7) &&
						(m_structMoveRobo.RoboStandortNeu.z > -6.3)) &&

						!((m_structMoveRobo.RoboStandortNeu.x > 8.7) &&	
						(m_structMoveRobo.RoboStandortNeu.x < 11.3) &&
						(m_structMoveRobo.RoboStandortNeu.z < -3.7) &&
						(m_structMoveRobo.RoboStandortNeu.z > -6.3)) &&

						!((m_structMoveRobo.RoboStandortNeu.x > -0.51) &&
						(m_structMoveRobo.RoboStandortNeu.x < 0.51) &&
						(m_structMoveRobo.RoboStandortNeu.z < -22.9)) &&

						!((m_structMoveRobo.RoboStandortNeu.x < -18.4) &&
						(m_structMoveRobo.RoboStandortNeu.x > -21.6) &&
						(m_structMoveRobo.RoboStandortNeu.z > 22.4)) &&

						!((m_structMoveRobo.RoboStandortNeu.x > 18.4) &&
						(m_structMoveRobo.RoboStandortNeu.x < 21.6) &&
						(m_structMoveRobo.RoboStandortNeu.z > 22.4))
						)
					{
						m_structMoveRobo.RoboStandort.x = m_structMoveRobo.RoboStandortNeu.x;
						m_structMoveRobo.RoboStandort.z = m_structMoveRobo.RoboStandortNeu.z;

						m_structMoveRobo.WheelLeft -= 5.0;
						if (m_structMoveRobo.WheelLeft < 0.0)
							m_structMoveRobo.WheelLeft = 359.0;

						m_structMoveRobo.WheelRight -= 5.0;
						if (m_structMoveRobo.WheelRight < 0.0)
							m_structMoveRobo.WheelRight = 359;
					}
				}
				break;
		case 'A':			// Drehung nach Rechts
				m_structMoveRobo.RoboDrehwinkel += 1.0;
				if (m_structMoveRobo.RoboDrehwinkel > 359.0)
					m_structMoveRobo.RoboDrehwinkel = 0.0;

				m_structMoveRobo.WheelRight += 2.0;
				if (m_structMoveRobo.WheelRight > 359.0)
					m_structMoveRobo.WheelRight = 0.0;
				m_structMoveRobo.WheelLeft -= 2.0;
				if (m_structMoveRobo.WheelLeft < 0.0)
					m_structMoveRobo.WheelLeft = 359.0;
				break;
		case 'D':			// Drehung nach Links
				m_structMoveRobo.RoboDrehwinkel -= 1.0;
				if (m_structMoveRobo.RoboDrehwinkel < 0.0)
					m_structMoveRobo.RoboDrehwinkel = 359.0;

				m_structMoveRobo.WheelLeft += 2.0;
				if (m_structMoveRobo.WheelLeft > 359.0)
					m_structMoveRobo.WheelLeft = 0.0;
				m_structMoveRobo.WheelRight -= 2.0;
				if (m_structMoveRobo.WheelRight < 0.0)
					m_structMoveRobo.WheelRight = 359.0;
				break;
		case 'Q':			// Arm links hoch
				m_structMoveRobo.ArmLinks -= 1.0;
				if (m_structMoveRobo.ArmLinks < 0.0)
					m_structMoveRobo.ArmLinks = 359.0;
				break;
		case 'Y':			// Arm links runter
				m_structMoveRobo.ArmLinks += 1.0;
				if (m_structMoveRobo.ArmLinks > 359.0)
					m_structMoveRobo.ArmLinks = 0.0;
				break;
		case 'E':			// Arm rechts hoch
				m_structMoveRobo.ArmRechts -= 1.0;
				if (m_structMoveRobo.ArmRechts < 0.0)
					m_structMoveRobo.ArmRechts = 359.0;
				break;
		case 'X':			// Arm rechts runter
				m_structMoveRobo.ArmRechts += 1.0;
				if (m_structMoveRobo.ArmRechts > 359.0)
					m_structMoveRobo.ArmRechts = 0.0;
				break;

		case 'R':			// Unterarm rechts hoch
				m_structMoveRobo.Unterarm -= 1.0;
				if (m_structMoveRobo.Unterarm < -135.0)
					m_structMoveRobo.Unterarm = -135.0;
				break;
		case 'T':			// Unterarm rechts runter
				m_structMoveRobo.Unterarm += 1.0;
				if (m_structMoveRobo.Unterarm > 0.0)
					m_structMoveRobo.Unterarm = 0.0;
				break;
		case 'F':			// Unterarm links hoch
				m_structMoveRobo.UnterarmLinks -= 1.0;
				if (m_structMoveRobo.UnterarmLinks < -135.0)
					m_structMoveRobo.UnterarmLinks = -135.0;
				break;
		case 'G':			// Unterarm links runter
				m_structMoveRobo.UnterarmLinks += 1.0;
				if (m_structMoveRobo.UnterarmLinks > 0.0)
					m_structMoveRobo.UnterarmLinks = 0.0;
				break;
		case 'Z':			// Finger zusammen fhren
				m_structMoveRobo.Finger += 0.01;
				if (m_structMoveRobo.Finger > 0.15)
					m_structMoveRobo.Finger = 0.15;
				break;
		case 'H':			// Hand nach rechts drehen
				m_structMoveRobo.Hand -= 3.0;
				if (m_structMoveRobo.Hand < 0.0)
					m_structMoveRobo.Hand = 359.0;
				break;
		case 'J':			// Hand nach links drehen
				m_structMoveRobo.Hand += 3.0;
				if (m_structMoveRobo.Hand > 359.0)
					m_structMoveRobo.Hand = 0.0;
				break;
		case 'V':			// SpotExponent +
				m_structMoveRobo.SpotExponent += 1.0;
				if (m_structMoveRobo.SpotExponent > 128.0)
					m_structMoveRobo.SpotExponent = 128.0;
				break;
		case 'B':			// SpotExponent -
				m_structMoveRobo.SpotExponent -= 1.0;
				if (m_structMoveRobo.SpotExponent < 0.0)
					m_structMoveRobo.SpotExponent = 0.0;
				break;
		case 'N':			// CutOff +
				m_structMoveRobo.SpotCutOff += 1.0;
				if (m_structMoveRobo.SpotCutOff > 90.0)
					m_structMoveRobo.SpotCutOff = 90.0;
				break;
		case 'M':			// CutOff -
				m_structMoveRobo.SpotCutOff -= 1.0;
				if (m_structMoveRobo.SpotCutOff < 0.0)
					m_structMoveRobo.SpotCutOff = 0.0;
				break;
		case 'O':			// Kopf rechts
				m_structMoveRobo.Kopf += 1.0;
				if (m_structMoveRobo.Kopf > 60.0)
					m_structMoveRobo.Kopf = 60.0;
				break;
		case 'P':			// Kopf links
				m_structMoveRobo.Kopf -= 1.0;
				if (m_structMoveRobo.Kopf < -60.0)
					m_structMoveRobo.Kopf = -60.0;
				break;
		case '1':			// Clipplane left +
				m_structClipplanes.left += 0.1f;
				break;
		case '2':			// Clipplane left -
				m_structClipplanes.left -= 0.1f;
				break;
		case '3':			// Clipplane right +
				m_structClipplanes.right += 0.1f;
				break;
		case '4':			// Clipplane right -
				m_structClipplanes.right -= 0.1f;
				break;
		case '5':			// Clipplane up +
				m_structClipplanes.up += 0.1f;
				break;
		case '6':			// Clipplane up -
				m_structClipplanes.up -= 0.1f;
				break;
		case '7':			// Clipplane down +
				m_structClipplanes.down += 0.1f;
				break;
		case '8':			// Clipplane down -
				m_structClipplanes.down -= 0.1f;
				break;
		case '9':			// Clipplane front +
				m_structClipplanes.front += 0.1f;
				break;
		case '0':			// Clipplane front -
				m_structClipplanes.front -= 0.1f;
				break;
		case 'U':			// Clipplane back +
				m_structClipplanes.back += 10.0f;
				break;
		case 'I':			// Clipplane back -
				m_structClipplanes.back -= 10.0f;
				break;

	}
	
	DrawScene();

	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}

void COpenGL::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// Keine Taste gedrckt

	while(m_structMoveRobo.Finger > 0.0)
	{
		m_structMoveRobo.Finger -= 0.01;
		DrawScene();
	}

	CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}

bool COpenGL::CalcNormale(dVektor *V1, dVektor *V2, dVektor *V3)
{
	/*	Klassenmethode zur Berechnung des Normalenvektors
		aus drei Flchenpunkten (Verticies).
		Es gilt die Regel der rechtshndigen Geometrie	*/

	dVektor V1V2, V1V3, KREUZ;					// lokale temporre Vektoren
	GLdouble Betrag;

	// Vorbereitung
	V1V2.x = V2->x - V1->x;						// Vektoren fr Kreuzprodukt-
	V1V2.y = V2->y - V1->y;						// berechnung ermitteln
	V1V2.z = V2->z - V1->z;
	V1V3.x = V3->x - V1->x;
	V1V3.y = V3->y - V1->y;
	V1V3.z = V3->z - V1->z;

	// Berechnung des Kreuzprodukts
	KREUZ.x = +((V1V2.y * V1V3.z) - (V1V2.z * V1V3.y));
	KREUZ.y = -((V1V2.x * V1V3.z) - (V1V2.z * V1V3.x));
	KREUZ.z = +((V1V2.x * V1V3.y) - (V1V2.y * V1V3.x));

	// Prfen des Vektors
	Betrag = sqrt(								// Lnge des Vektors ermitteln
					pow(KREUZ.x, 2.0)
				+	pow(KREUZ.y, 2.0)
				+	pow(KREUZ.z, 2.0));
	if (Betrag == 0)							// Normalenvektor muss lnger
		return false;							// als Nullvektor sein

	// Normalenvektor als Einsvektor abspeichern
	m_structOGLStatus.vLastNormale.x = KREUZ.x / Betrag;
	m_structOGLStatus.vLastNormale.y = KREUZ.y / Betrag;
	m_structOGLStatus.vLastNormale.z = KREUZ.z / Betrag;

	return true;								// Normalenvektor wurde berechnet
}

bool COpenGL::SetMatCol(fRGBAColor *pCurMatColor, GLenum MatFace, GLfloat Ca, GLfloat Cd, GLfloat Cs)
{
	// Funktion zur Materialbestimmung im glMaterial Modus

	fRGBAColor SetColAmbient, SetColDiffuse, SetColSpecular;

	// Reflexionsintensitt fr ...

		// ambientes Licht
		SetColAmbient.Red		= pCurMatColor->Red		* Ca;
		SetColAmbient.Green		= pCurMatColor->Green	* Ca;
		SetColAmbient.Blue		= pCurMatColor->Blue	* Ca;
		SetColAmbient.Alpha		= pCurMatColor->Alpha;

		// diffuses Licht
		SetColDiffuse.Red		= pCurMatColor->Red		* Cd;
		SetColDiffuse.Green		= pCurMatColor->Green	* Cd;
		SetColDiffuse.Blue		= pCurMatColor->Blue	* Cd;
		SetColDiffuse.Alpha		= pCurMatColor->Alpha;

		// spekulares Licht
		SetColSpecular.Red		= pCurMatColor->Red		* Cs;
		SetColSpecular.Green	= pCurMatColor->Green	* Cs;
		SetColSpecular.Blue		= pCurMatColor->Blue	* Cs;
		SetColSpecular.Alpha	= pCurMatColor->Alpha;

		// Materialfarbe setzen
		glMaterialfv(MatFace, GL_AMBIENT, &SetColAmbient.Red);
		glMaterialfv(MatFace, GL_DIFFUSE, &SetColDiffuse.Red);
		glMaterialfv(MatFace, GL_SPECULAR, &SetColSpecular.Red);

	return true;

}

void COpenGL::OnSize(UINT nType, int cx, int cy) 
{
	// Auf Fenster-Resize reagieren

	CFrameWnd::OnSize(nType, cx, cy);

	DrawScene();

	
}

bool COpenGL::LoadPrepareCurTexture(CString Filename, GLuint *pTexName, 
									GLint MinFilter, GLint MagFilter)
{
	// Funktion zum Laden von Texturen

	HBITMAP hBmp = (HBITMAP)::LoadImage					// Bitmap laden
		(	NULL,
			(LPCTSTR) Filename,							// Dateiname
			IMAGE_BITMAP,								// Formathinweis
			0, 0,										// Gesamte Bitmap
			LR_LOADFROMFILE								// Ladeformat
			| LR_CREATEDIBSECTION);

	if (hBmp == NULL) return false;						// Ladeprobleme

	BITMAP BM;											// Bitmap-Info holen
	::GetObject (hBmp,sizeof (BM),&BM);					// Win32-Api-Funktion
	if (BM.bmBitsPixel != 24)							// 24-Bit Bitmap?
		return false;									// nicht brauchbar

	if (!*pTexName)										// Textur schon vorhanden?
		glGenTextures(1, pTexName);						// Nein, Namen geben
	else return false;									// Ja, Abbruch

	glBindTexture(GL_TEXTURE_2D, *pTexName);			// Textur speichern
	glPixelStorei(GL_UNPACK_ALIGNMENT, 4);				// Pixelablagerart
	glPixelStorei(GL_UNPACK_ROW_LENGTH, 0);				// 0-gesamte Textur
	glPixelStorei(GL_UNPACK_SKIP_ROWS, 0);				// 0-gesamte Textur
	glPixelStorei(GL_UNPACK_SKIP_PIXELS, 0);			// 0-gesamte Textur

	glTexParameteri(GL_TEXTURE_2D,						// Textur-Parameter
		GL_TEXTURE_MAG_FILTER, MagFilter);
	glTexParameteri(GL_TEXTURE_2D,
		GL_TEXTURE_MIN_FILTER, MinFilter);
	glTexParameteri(GL_TEXTURE_2D,
		GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D,
		GL_TEXTURE_WRAP_T, GL_REPEAT);

	// Texturumgebung definieren
	glTexEnvf(GL_TEXTURE_ENV,
		GL_TEXTURE_ENV_MODE, GL_MODULATE);				// Ersetzmodus

	// Texture Mipmap bilden
	gluBuild2DMipmaps(
		GL_TEXTURE_2D,									// Textur-Mipmap
		3,												// Anzahl Farbkomponenten
		BM.bmWidth, BM.bmHeight,						// Breite / Hhe Bitmap
		GL_BGR_EXT,										// Hinweis auf BGR-Format
		GL_UNSIGNED_BYTE,								// Datenformat
		BM.bmBits);										// Zeiger auf Bitmap

	glBindTexture(GL_TEXTURE_2D, 0);					// Texturablage beendet

	return true;
}

bool COpenGL::SetAttribs()
{
	// Attribute setzen
	glNewList((GLint) ATTRIBS,GL_COMPILE_AND_EXECUTE);
		glClearColor(0.0F,0.0F,0.0F,1.0F);	// Hintergrundfarbe (schwarz)
		glClear(GL_COLOR_BUFFER_BIT |		// Farb-Puffer lschen
				GL_DEPTH_BUFFER_BIT);		// Z-Buffer lschen

		// Darstellungs und Steuerungsarten
			// Status von OpenGL definieren
			glEnable(GL_NORMALIZE);

			if (m_structOGLStatus.bZbuffer == GL_TRUE)	// Z-Buffer
				glEnable(GL_DEPTH_TEST);
			else
				glDisable(GL_DEPTH_TEST);

			if (m_structOGLStatus.bLight == GL_TRUE)	// Beleuchtungsmodus
				glEnable(GL_LIGHTING);
			else					
				glDisable(GL_LIGHTING);

			if(m_structOGLStatus.bLightMode == GL_TRUE)
				glEnable(GL_COLOR_MATERIAL);			// glColor Modeif(m_structOGLStatus.bLightMode == GL_TRUE)
			else
				glDisable(GL_COLOR_MATERIAL);			// glMaterial Mode

			glDisable(GL_CULL_FACE);

			if (m_structOGLStatus.bBlend == GL_TRUE)	// Transparenzeffekte aktivieren
				glEnable(GL_BLEND);
			else 
				glDisable(GL_BLEND);

			if (m_structOGLStatus.bFog == GL_TRUE)
				glEnable(GL_FOG);						// Nebel aktivieren
			else
				glDisable(GL_FOG);

			// sonstiges
			glBlendFunc(								// Transparenzeffekte definieren
				GL_SRC_ALPHA,
				GL_ONE_MINUS_SRC_ALPHA);
			glFrontFace(GL_CCW);
			glCullFace(GL_BACK);
			if (m_structOGLStatus.bFillModeLines == GL_TRUE)	// Gitternetzdarstellung
				glPolygonMode(
					GL_FRONT_AND_BACK,
					GL_LINE);
			else
				glPolygonMode(
					GL_FRONT_AND_BACK,
					GL_FILL);

			if (m_structOGLStatus.bShadingSmooth == GL_TRUE)
				glShadeModel(GL_SMOOTH);						// Smooth-Shading
			else
				glShadeModel(GL_FLAT);							// Flat-Shading
	
			// Globale Beleuchtungsdefinition
			GLfloat LModelAmbient[4]
				= {0.2F,0.2F,0.2F,1.0F};
			glLightModelfv(
				GL_LIGHT_MODEL_AMBIENT,
				&LModelAmbient[0]);
			glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,1);
			glColorMaterial(
				GL_FRONT,
				GL_AMBIENT_AND_DIFFUSE);

			// Lichtquellen
			if (m_structOGLStatus.bLight0 == GL_TRUE)		// Parallelstrahler an/aus
				glEnable(GL_LIGHT0);
			else
				glDisable(GL_LIGHT0);

			if (m_structOGLStatus.bLight1 == GL_TRUE)		// Laternen an/aus
			{
				glEnable(GL_LIGHT1);
				glEnable(GL_LIGHT2);
			}
			else
			{
				glDisable(GL_LIGHT1);
				glDisable(GL_LIGHT2);
			}

			if (m_structOGLStatus.bLight2 == GL_TRUE)		// Strahler an/aus
				glEnable(GL_LIGHT3);
			else
				glDisable(GL_LIGHT3);

			if (m_structOGLStatus.bBeamer == GL_TRUE)		// Strahler an/aus
				glEnable(GL_LIGHT4);
			else
				glDisable(GL_LIGHT4);
	glEndList();

	return true;
}

bool COpenGL::DrawScene()
{
	// Szene berechnen und darstellen

	// Perspektive setzen
	SetCurPerspektive();
	// Primitiv-Listen  generieren, gruppieren und ausfhren
	SetCurModel();

	glFlush();
	glFinish();
	SwapBuffers(wglGetCurrentDC());			// verhindert flackern

	return true;
}
